/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-angular-core";
import { HorizontalAlignment_$type } from "igniteui-angular-core";
import { VerticalAlignment_$type } from "igniteui-angular-core";
import { Visibility_$type } from "igniteui-angular-core";
import { ValueAxisLabelLocation_$type } from "./ValueAxisLabelLocation";
import { AngleAxisLabelLocation_$type } from "./AngleAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-angular-core";
/**
 * @hidden
 */
export let RadialBaseChart = /*@__PURE__*/ (() => {
    class RadialBaseChart extends DomainChart {
        constructor() {
            super(...arguments);
            this.aas = null;
            this.aat = null;
            this.aa7 = 0;
            this.aa9 = 5;
            this.aa8 = 0;
            this.aa6 = 5;
            this.abq = 5;
            this.abs = 0;
            this.abr = 5;
            this.abp = 0;
            this.agt = null;
            this.ag0 = null;
            this.agr = null;
            this.ags = null;
            this.abk = 0;
            this.ab3 = 0;
            this.abj = NaN;
            this.ab2 = NaN;
            this.abm = NaN;
            this.ab5 = NaN;
            this.abl = NaN;
            this.ab4 = NaN;
            this.abi = NaN;
            this.ab1 = NaN;
            this.agz = null;
            this.ag6 = null;
            this.adh = null;
            this.adl = null;
            this.adj = null;
            this.adn = null;
            this.adc = null;
            this.add = null;
            this.agu = null;
            this.ag1 = null;
            this.aba = DeviceUtils.g(1);
            this.abt = DeviceUtils.g(1);
            this.abd = DeviceUtils.g(1);
            this.abw = DeviceUtils.g(1);
            this.agw = null;
            this.ag3 = null;
            this.agx = null;
            this.ag4 = null;
            this.abe = DeviceUtils.g(1);
            this.abx = DeviceUtils.g(1);
            this.abf = DeviceUtils.g(8);
            this.aby = 0;
            this.agy = null;
            this.ag5 = null;
            this.abg = DeviceUtils.g(1);
            this.abz = DeviceUtils.g(1);
            this.adi = null;
            this.adm = null;
            this.agv = null;
            this.ag2 = null;
            this.aa5 = 0;
            this.abo = 0;
            this.aa4 = NaN;
            this.abb = NaN;
            this.abc = NaN;
            this.abn = NaN;
            this.abu = NaN;
            this.abv = NaN;
            this.abh = 0;
            this.ab0 = -90;
            this.aa0 = false;
            this.aa1 = false;
            this.agm = 1;
            this.ahp = 1;
            this.agl = 1;
            this.agn = 2;
            this.ahn = 0;
            this.aho = 1;
            this.aht = 0;
            this.ahu = 0;
            this.aay = 4;
            this.aao = 4;
            this.adg = null;
            this.aak = null;
            this.adk = null;
            this.aal = null;
        }
        provideContainer(a) {
            if (a != null) {
                let b = this.aaq();
                let c = this.aar();
                if (b != null) {
                    b.provideRenderer(a);
                }
                if (c != null) {
                    c.provideRenderer(a);
                }
            }
            super.provideContainer(a);
        }
        vm() {
            super.vm();
            let a = this.aaq();
            let b = this.aar();
            if (a != null && a.az != null) {
                this.ag9 = a.az.textColor;
            }
            if (b != null && b.az != null) {
                this.ahg = b.az.textColor;
            }
            this.ahe = AxisDefaults.axis_TickBrush;
            this.ahl = AxisDefaults.axis_TickBrush;
            this.aha = AxisDefaults.axis_MajorBrush;
            this.ahh = AxisDefaults.axis_MajorBrush;
            this.ahd = AxisDefaults.axis_LineBrush;
            this.ahk = AxisDefaults.axis_LineBrush;
        }
        wh(a, b, c) {
            super.wh(a, b, c);
            switch (a) {
                case "AngleAxisLabelLeftMargin":
                    this.agd((d) => d.leftMargin = this.ab9);
                    break;
                case "AngleAxisLabelTopMargin":
                    this.agd((d) => d.topMargin = this.acb);
                    break;
                case "AngleAxisLabelRightMargin":
                    this.agd((d) => d.rightMargin = this.aca);
                    break;
                case "AngleAxisLabelBottomMargin":
                    this.agd((d) => d.bottomMargin = this.ab8);
                    break;
                case "ValueAxisLabelLeftMargin":
                    this.agi((d) => d.leftMargin = this.acw);
                    break;
                case "ValueAxisLabelTopMargin":
                    this.agi((d) => d.topMargin = this.acy);
                    break;
                case "ValueAxisLabelRightMargin":
                    this.agi((d) => d.rightMargin = this.acx);
                    break;
                case "ValueAxisLabelBottomMargin":
                    this.agi((d) => d.bottomMargin = this.acv);
                    break;
                case "ActualItemsSource":
                case "ShouldDisplayMockData":
                case "ShouldUseSkeletonStyleForMockData":
                    this.ag7 = this.zi(this.ag9);
                    this.ag8 = this.zi(this.ahg);
                    break;
                case "AngleAxisLabelTextColor":
                    this.ag7 = this.zi(this.ag9);
                    break;
                case "ValueAxisLabelTextColor":
                    this.ag8 = this.zi(this.ahg);
                    break;
                case "ActualAngleAxisLabelTextColor":
                    this.agd((d) => d.textColor = this.ag7);
                    break;
                case "ActualValueAxisLabelTextColor":
                    this.agi((d) => d.textColor = this.ag8);
                    break;
                case "AngleAxisTitleMargin":
                    this.agf((d) => d.margin = this.acm);
                    break;
                case "ValueAxisTitleMargin":
                    this.agk((d) => d.margin = this.ac9);
                    break;
                case "AngleAxisTitleLeftMargin":
                    this.agf((d) => d.leftMargin = this.acl);
                    break;
                case "ValueAxisTitleLeftMargin":
                    this.agk((d) => d.leftMargin = this.ac8);
                    break;
                case "AngleAxisTitleTopMargin":
                    this.agf((d) => d.topMargin = this.aco);
                    break;
                case "ValueAxisTitleTopMargin":
                    this.agk((d) => d.topMargin = this.adb);
                    break;
                case "AngleAxisTitleRightMargin":
                    this.agf((d) => d.rightMargin = this.acn);
                    break;
                case "ValueAxisTitleRightMargin":
                    this.agk((d) => d.rightMargin = this.ada);
                    break;
                case "AngleAxisTitleBottomMargin":
                    this.agf((d) => d.bottomMargin = this.ack);
                    break;
                case "ValueAxisTitleBottomMargin":
                    this.agk((d) => d.bottomMargin = this.ac7);
                    break;
                case "AngleAxisTitleTextColor":
                    this.agf((d) => d.textColor = this.ahf);
                    break;
                case "ValueAxisTitleTextColor":
                    this.agk((d) => d.textColor = this.ahm);
                    break;
                case "AngleAxisFormatLabel":
                    this.agb((d) => d.au = this.aau);
                    break;
                case "ValueAxisFormatLabel":
                    this.agg((d) => d.au = this.aav);
                    break;
            }
        }
        get aau() {
            return this.aas;
        }
        set aau(a) {
            let b = this.aau;
            if (a != b) {
                this.aas = a;
                this.wd("AngleAxisFormatLabel", b, this.aau);
            }
        }
        get aav() {
            return this.aat;
        }
        set aav(a) {
            let b = this.aav;
            if (a != b) {
                this.aat = a;
                this.wd("ValueAxisFormatLabel", b, this.aav);
            }
        }
        get ab9() {
            return this.aa7;
        }
        set ab9(a) {
            let b = this.ab9;
            if (a != b) {
                this.aa7 = a;
                this.wd("AngleAxisLabelLeftMargin", b, this.ab9);
            }
        }
        get acb() {
            return this.aa9;
        }
        set acb(a) {
            let b = this.acb;
            if (a != b) {
                this.aa9 = a;
                this.wd("AngleAxisLabelTopMargin", b, this.acb);
            }
        }
        get aca() {
            return this.aa8;
        }
        set aca(a) {
            let b = this.aca;
            if (a != b) {
                this.aa8 = a;
                this.wd("AngleAxisLabelRightMargin", b, this.aca);
            }
        }
        get ab8() {
            return this.aa6;
        }
        set ab8(a) {
            let b = this.ab8;
            if (a != b) {
                this.aa6 = a;
                this.wd("AngleAxisLabelBottomMargin", b, this.ab8);
            }
        }
        get acw() {
            return this.abq;
        }
        set acw(a) {
            let b = this.acw;
            if (a != b) {
                this.abq = a;
                this.wd("ValueAxisLabelLeftMargin", b, this.acw);
            }
        }
        get acy() {
            return this.abs;
        }
        set acy(a) {
            let b = this.acy;
            if (a != b) {
                this.abs = a;
                this.wd("ValueAxisLabelTopMargin", b, this.acy);
            }
        }
        get acx() {
            return this.abr;
        }
        set acx(a) {
            let b = this.acx;
            if (a != b) {
                this.abr = a;
                this.wd("ValueAxisLabelRightMargin", b, this.acx);
            }
        }
        get acv() {
            return this.abp;
        }
        set acv(a) {
            let b = this.acv;
            if (a != b) {
                this.abp = a;
                this.wd("ValueAxisLabelBottomMargin", b, this.acv);
            }
        }
        get ag9() {
            return this.agt;
        }
        set ag9(a) {
            let b = this.ag9;
            if (a != b) {
                this.agt = a;
                this.wd("AngleAxisLabelTextColor", b, this.ag9);
            }
        }
        get ahg() {
            return this.ag0;
        }
        set ahg(a) {
            let b = this.ahg;
            if (a != b) {
                this.ag0 = a;
                this.wd("ValueAxisLabelTextColor", b, this.ahg);
            }
        }
        get ag7() {
            return this.agr;
        }
        set ag7(a) {
            let b = this.agr;
            if (a != b) {
                this.agr = a;
                this.wd("ActualAngleAxisLabelTextColor", b, this.ag7);
            }
        }
        get ag8() {
            return this.ags;
        }
        set ag8(a) {
            let b = this.ags;
            if (a != b) {
                this.ags = a;
                this.wd("ActualValueAxisLabelTextColor", b, this.ag8);
            }
        }
        get acm() {
            return this.abk;
        }
        set acm(a) {
            let b = this.acm;
            if (a != b) {
                this.abk = a;
                this.wd("AngleAxisTitleMargin", b, this.acm);
            }
        }
        get ac9() {
            return this.ab3;
        }
        set ac9(a) {
            let b = this.ac9;
            if (a != b) {
                this.ab3 = a;
                this.wd("ValueAxisTitleMargin", b, this.ac9);
            }
        }
        get acl() {
            return this.abj;
        }
        set acl(a) {
            let b = this.acl;
            if (a != b) {
                this.abj = a;
                this.wd("AngleAxisTitleLeftMargin", b, this.acl);
            }
        }
        get ac8() {
            return this.ab2;
        }
        set ac8(a) {
            let b = this.ac8;
            if (a != b) {
                this.ab2 = a;
                this.wd("ValueAxisTitleLeftMargin", b, this.ac8);
            }
        }
        get aco() {
            return this.abm;
        }
        set aco(a) {
            let b = this.aco;
            if (a != b) {
                this.abm = a;
                this.wd("AngleAxisTitleTopMargin", b, this.aco);
            }
        }
        get adb() {
            return this.ab5;
        }
        set adb(a) {
            let b = this.adb;
            if (a != b) {
                this.ab5 = a;
                this.wd("ValueAxisTitleTopMargin", b, this.adb);
            }
        }
        get acn() {
            return this.abl;
        }
        set acn(a) {
            let b = this.acn;
            if (a != b) {
                this.abl = a;
                this.wd("AngleAxisTitleRightMargin", b, this.acn);
            }
        }
        get ada() {
            return this.ab4;
        }
        set ada(a) {
            let b = this.ada;
            if (a != b) {
                this.ab4 = a;
                this.wd("ValueAxisTitleRightMargin", b, this.ada);
            }
        }
        get ack() {
            return this.abi;
        }
        set ack(a) {
            let b = this.ack;
            if (a != b) {
                this.abi = a;
                this.wd("AngleAxisTitleBottomMargin", b, this.ack);
            }
        }
        get ac7() {
            return this.ab1;
        }
        set ac7(a) {
            let b = this.ac7;
            if (a != b) {
                this.ab1 = a;
                this.wd("ValueAxisTitleBottomMargin", b, this.ac7);
            }
        }
        get ahf() {
            return this.agz;
        }
        set ahf(a) {
            let b = this.ahf;
            if (a != b) {
                this.agz = a;
                this.wd("AngleAxisTitleTextColor", b, this.ahf);
            }
        }
        get ahm() {
            return this.ag6;
        }
        set ahm(a) {
            let b = this.ahm;
            if (a != b) {
                this.ag6 = a;
                this.wd("ValueAxisTitleTextColor", b, this.ahm);
            }
        }
        wi(a, b, c) {
            super.wi(a, b, c);
            switch (a) {
                case "AngleAxisLabelTextStyle":
                    this.agd((d) => d.textStyle = this.ad4);
                    break;
                case "ValueAxisLabelTextStyle":
                    this.agi((d) => d.textStyle = this.afc);
                    break;
                case "AngleAxisTitleTextStyle":
                    this.agf((d) => d.textStyle = this.aeu);
                    break;
                case "ValueAxisTitleTextStyle":
                    this.agk((d) => d.textStyle = this.af2);
                    break;
            }
        }
        get ad4() {
            return this.adh;
        }
        set ad4(a) {
            let b = this.ad4;
            if (a != b) {
                this.adh = a;
                this.wd("AngleAxisLabelTextStyle", b, this.ad4);
            }
        }
        get afc() {
            return this.adl;
        }
        set afc(a) {
            let b = this.afc;
            if (a != b) {
                this.adl = a;
                this.wd("ValueAxisLabelTextStyle", b, this.afc);
            }
        }
        get aeu() {
            return this.adj;
        }
        set aeu(a) {
            let b = this.aeu;
            if (a != b) {
                this.adj = a;
                this.wd("AngleAxisTitleTextStyle", b, this.aeu);
            }
        }
        get af2() {
            return this.adn;
        }
        set af2(a) {
            let b = this.af2;
            if (a != b) {
                this.adn = a;
                this.wd("ValueAxisTitleTextStyle", b, this.af2);
            }
        }
        af8(a) {
            this.af5(a, (b) => b.leftMargin = this.ab9);
            this.af5(a, (b) => b.topMargin = this.acb);
            this.af5(a, (b) => b.rightMargin = this.aca);
            this.af5(a, (b) => b.bottomMargin = this.ab8);
            this.af5(a, (b) => b.textColor = this.ag7);
            this.af6(a, (b) => b.textColor = this.ahf);
            this.af6(a, (b) => b.leftMargin = this.acl);
            this.af6(a, (b) => b.topMargin = this.aco);
            this.af6(a, (b) => b.rightMargin = this.acn);
            this.af6(a, (b) => b.bottomMargin = this.ack);
            this.af5(a, (b) => b.textStyle = this.ad4);
            this.af6(a, (b) => b.textStyle = this.aeu);
        }
        aga(a) {
            this.af5(a, (b) => b.leftMargin = this.acw);
            this.af5(a, (b) => b.topMargin = this.acy);
            this.af5(a, (b) => b.rightMargin = this.acx);
            this.af5(a, (b) => b.bottomMargin = this.acv);
            this.af5(a, (b) => b.textColor = this.ag8);
            this.af6(a, (b) => b.textColor = this.ahm);
            this.af6(a, (b) => b.leftMargin = this.ac8);
            this.af6(a, (b) => b.topMargin = this.adb);
            this.af6(a, (b) => b.rightMargin = this.ada);
            this.af6(a, (b) => b.bottomMargin = this.ac7);
            this.af5(a, (b) => b.textStyle = this.afc);
            this.af6(a, (b) => b.textStyle = this.af2);
        }
        w9(a) {
            let b = this.be(a);
            let c = this.dc(a, b);
            if (c == null) {
                return;
            }
            c.itemsSource = this.h6(a);
            if (a.highlightedData != null) {
                c.highlightedItemsSource = this.h7(a);
            }
            c.name = this.q0(a);
            c.title = this.q1(a, b);
            this.dataChart.series.add(c);
        }
        agb(a) {
            this.agc(a, null);
        }
        agc(a, b) {
            a(this.aaq());
        }
        agh(a, b) {
            a(this.aar());
        }
        agg(a) {
            this.agh(a, true);
        }
        u5(a, b) {
            this.agb(a);
            this.agh(a, b);
        }
        agf(a) {
            this.af6(this.aaq(), a);
        }
        agk(a) {
            this.af6(this.aar(), a);
        }
        agi(a) {
            this.af5(this.aar(), a);
        }
        agd(a) {
            this.af5(this.aaq(), a);
        }
        acp(a) {
            let b = this.aaq();
            return b.el(a, new ScalerParams(1, this.zr, this.zq, b.ch));
        }
        acr(a) {
            let b = this.aaq();
            return b.eo(a, new ScalerParams(1, this.zr, this.zq, b.ch));
        }
        acq(a) {
            let b = this.aar();
            return b.el(a, new ScalerParams(1, this.zr, this.zq, b.ch));
        }
        acs(a) {
            let b = this.aar();
            return b.eo(a, new ScalerParams(1, this.zr, this.zq, b.ch));
        }
        w6(a) {
            super.w6(a);
            if (a == null) {
                return;
            }
            if (a.axes != null) {
                let b = this.aaq();
                let c = this.aar();
                if (a.axes.contains(b)) {
                    a.axes.remove(b);
                }
                if (a.axes.contains(c)) {
                    a.axes.remove(c);
                }
            }
        }
        static aex(a, b) {
            for (let c of fromEnum(b)) {
                let d = c.findMatchingHint(16);
                if (d != null) {
                    let e = d.path;
                    return e;
                }
            }
            return null;
        }
        vh(a, b) {
            super.vh(a, b);
            if (a == this.dataChart) {
                this.dataChart.axes.add(this.aaq());
                this.dataChart.axes.add(this.aar());
            }
        }
        af7(a) {
            if (a != null && this.l4 != null && a.fn == null) {
                a.provideRenderer(this.l4);
            }
            a.jz = this.aha;
            a.et = this.acc;
            a.j0 = this.ahb;
            a.ew = this.acf;
            a.j2 = this.ahd;
            a.fi = this.acg;
            a.j1 = this.ahc;
            a.fj = this.ach;
            a.j3 = this.ahe;
            a.fk = this.aci;
            a.c4 = true;
            a.cu = this.shouldAvoidAxisAnnotationCollisions;
            a.cw = this.shouldAvoidAxisAnnotationCollisions;
            let b = a == this.aaq();
            if (b) {
                a.g8 = this.ael;
            }
            a.f2 = this.ade;
            a.gi = this.adv;
            a.ah = this.aam;
            this.af5(a, (c) => c.angle = this.ab7);
            this.af5(a, (c) => {
                if (c.extent != this.ab6) {
                    c.extent = this.ab6;
                }
            });
            this.af5(a, (c) => {
                if (c.maximumExtent != this.acd) {
                    c.maximumExtent = this.acd;
                }
            });
            this.af5(a, (c) => {
                if (c.maximumExtentPercentage != this.ace) {
                    c.maximumExtentPercentage = this.ace;
                }
            });
            this.af5(a, (c) => c.horizontalAlignment = this.ago);
            this.af5(a, (c) => c.verticalAlignment = this.ahq);
            this.af5(a, (c) => c.visibility = this.ahv);
            this.af5(a, (c) => c.location = this.aaw(this.aap));
            this.af6(a, (c) => c.horizontalAlignment = this.agp);
            this.af6(a, (c) => c.angle = this.acj);
            this.af8(a);
        }
        af9(a) {
            if (a == null) {
                return;
            }
            if (this.l4 != null && a.fn == null) {
                a.provideRenderer(this.l4);
            }
            a.cu = this.shouldAvoidAxisAnnotationCollisions;
            a.cw = this.shouldAvoidAxisAnnotationCollisions;
            this.af5(a, (b) => b.angle = this.acu);
            this.af5(a, (b) => {
                if (b.extent != this.act) {
                    b.extent = this.act;
                }
            });
            this.af5(a, (b) => {
                if (b.maximumExtent != this.ac0) {
                    b.maximumExtent = this.ac0;
                }
            });
            this.af5(a, (b) => {
                if (b.maximumExtentPercentage != this.ac1) {
                    b.maximumExtentPercentage = this.ac1;
                }
            });
            this.af5(a, (b) => b.horizontalAlignment = this.agq);
            this.af5(a, (b) => b.verticalAlignment = this.ahr);
            this.af5(a, (b) => b.visibility = this.ahw);
            this.af5(a, (b) => b.location = this.aax(this.aaz));
            this.af6(a, (b) => b.verticalAlignment = this.ahs);
            this.af6(a, (b) => b.angle = this.ac6);
            a.jz = this.ahh;
            a.et = this.acz;
            a.j0 = this.ahi;
            a.ew = this.ac2;
            a.j2 = this.ahk;
            a.fi = this.ac3;
            a.j1 = this.ahj;
            a.fj = this.ac4;
            a.j3 = this.ahl;
            a.fk = this.ac5;
            let b = a == this.aar();
            if (b) {
                a.g8 = this.aft;
            }
            a.gi = this.ae3;
            a.ah = this.aan;
            this.aga(a);
        }
        ve() {
            super.ve();
            this.af7(this.aaq());
            this.af9(this.aar());
        }
        af5(a, b) {
            if (a == null) {
                return;
            }
            if (a.az == null) {
                a.az = new AxisLabelSettings();
                a.az.angle = a.d7();
                a.az.bottomMargin = a.d8();
                a.az.leftMargin = a.d9();
                a.az.rightMargin = a.ea();
                a.az.topMargin = a.eb();
                a.az.horizontalAlignment = a.ju();
                a.az.location = a.a0();
                a.az.verticalAlignment = a.ko();
            }
            b(a.az);
        }
        af6(a, b) {
            if (a == null) {
                return;
            }
            if (a.bf == null) {
                a.bf = new TitleSettings();
                a.bf.bottomMargin = a.ed();
                a.bf.leftMargin = a.ee();
                a.bf.rightMargin = a.ef();
                a.bf.topMargin = a.eg();
                a.bf.location = a.a1();
                a.bf.angle = a.ec();
                a.bf.horizontalAlignment = a.jv();
                a.bf.verticalAlignment = a.kp();
            }
            b(a.bf);
        }
        wd(a, b, c) {
            super.wd(a, b, c);
            switch (a) {
                case "AngleAxisLabelAngle":
                    this.agd((d) => d.angle = this.ab7);
                    break;
                case "ValueAxisLabelAngle":
                    this.agi((d) => d.angle = this.acu);
                    break;
                case "AngleAxisLabelHorizontalAlignment":
                    this.agd((d) => d.horizontalAlignment = this.ago);
                    break;
                case "ValueAxisLabelHorizontalAlignment":
                    this.agi((d) => d.horizontalAlignment = this.agq);
                    break;
                case "AngleAxisLabelVerticalAlignment":
                    this.agd((d) => d.verticalAlignment = this.ahq);
                    break;
                case "ValueAxisLabelVerticalAlignment":
                    this.agi((d) => d.verticalAlignment = this.ahr);
                    break;
                case "AngleAxisLabelVisibility":
                    this.agd((d) => d.visibility = this.ahv);
                    break;
                case "ValueAxisLabelVisibility":
                    this.agi((d) => d.visibility = this.ahw);
                    break;
                case "AngleAxisLabel":
                    this.agb((d) => d.f2 = this.ade);
                    break;
                case "ValueAxisLabel":
                    this.agg((d) => d.f2 = this.adf);
                    break;
                case "AngleAxisLabelFormat":
                    this.agb((d) => d.gi = this.adv);
                    break;
                case "AngleAxisLabelFormatSpecifiers":
                    this.agb((d) => d.ah = this.aam);
                    break;
                case "ValueAxisLabelFormat":
                    this.agg((d) => d.gi = this.ae3);
                    break;
                case "ValueAxisLabelFormatSpecifiers":
                    this.agg((d) => d.ah = this.aan);
                    break;
                case "AngleAxisTitleAngle":
                    this.agf((d) => d.angle = this.acj);
                    break;
                case "ValueAxisTitleAngle":
                    this.agk((d) => d.angle = this.ac6);
                    break;
                case "AngleAxisTitleAlignment":
                    this.agf((d) => d.horizontalAlignment = this.agp);
                    break;
                case "ValueAxisTitleAlignment":
                    this.agk((d) => d.verticalAlignment = this.ahs);
                    break;
                case "AngleAxisTitle":
                    this.agb((d) => d.g8 = this.ael);
                    break;
                case "ValueAxisTitle":
                    this.agh((d) => d.g8 = this.aft, false);
                    break;
                case "AngleAxisMajorStroke":
                    this.agc((d) => d.jz = this.aha, a);
                    break;
                case "ValueAxisMajorStroke":
                    this.agg((d) => d.jz = this.ahh);
                    break;
                case "AngleAxisMajorStrokeThickness":
                    this.agc((d) => d.et = this.acc, a);
                    break;
                case "ValueAxisMajorStrokeThickness":
                    this.agg((d) => d.et = this.acz);
                    break;
                case "AngleAxisMinorStroke":
                    this.agb((d) => d.j0 = this.ahb);
                    break;
                case "ValueAxisMinorStroke":
                    this.agg((d) => d.j0 = this.ahi);
                    break;
                case "AngleAxisMinorStrokeThickness":
                    this.agb((d) => d.ew = this.acf);
                    break;
                case "ValueAxisMinorStrokeThickness":
                    this.agg((d) => d.ew = this.ac2);
                    break;
                case "AngleAxisTickLength":
                    this.agb((d) => d.fj = this.ach);
                    break;
                case "ValueAxisTickLength":
                    this.agg((d) => d.fj = this.ac4);
                    break;
                case "AngleAxisTickStroke":
                    this.agb((d) => d.j3 = this.ahe);
                    break;
                case "ValueAxisTickStroke":
                    this.agg((d) => d.j3 = this.ahl);
                    break;
                case "AngleAxisTickStrokeThickness":
                    this.agb((d) => d.fk = this.aci);
                    break;
                case "ValueAxisTickStrokeThickness":
                    this.agg((d) => d.fk = this.ac5);
                    break;
                case "AngleAxisStroke":
                    this.agb((d) => d.j2 = this.ahd);
                    break;
                case "ValueAxisStroke":
                    this.agg((d) => d.j2 = this.ahk);
                    break;
                case "AngleAxisStrokeThickness":
                    this.agb((d) => d.fi = this.acg);
                    break;
                case "ValueAxisStrokeThickness":
                    this.agg((d) => d.fi = this.ac3);
                    break;
                case "AngleAxisExtent":
                    this.agd((d) => d.extent = this.ab6);
                    break;
                case "AngleAxisMaximumExtent":
                    this.agd((d) => d.maximumExtent = this.acd);
                    break;
                case "AngleAxisMaximumExtentPercentage":
                    this.agd((d) => d.maximumExtentPercentage = this.ace);
                    break;
                case "ValueAxisExtent":
                    this.agi((d) => d.extent = this.act);
                    break;
                case "ValueAxisMaximumExtent":
                    this.agi((d) => d.maximumExtent = this.acd);
                    break;
                case "ValueAxisMaximumExtentPercentage":
                    this.agi((d) => d.maximumExtentPercentage = this.ace);
                    break;
                case "AngleAxisStrip":
                    this.agb((d) => d.j1 = this.ahc);
                    break;
                case "ValueAxisStrip":
                    this.agg((d) => d.j1 = this.ahj);
                    break;
                case "AngleAxisInverted":
                    this.agb((d) => d.ch = this.aa2);
                    break;
                case "ValueAxisInverted":
                    this.agg((d) => d.ch = this.aa3);
                    break;
                case "ValueAxisLabelLocation":
                    this.agj();
                    break;
                case "AngleAxisLabelLocation":
                    this.age();
                    break;
            }
        }
        agj() {
            let a = this.aax(this.aaz);
            if (a == 2 || a == 7) {
                this.agq = 2;
            }
            else {
                this.agq = 0;
            }
            this.agi((b) => b.location = a);
        }
        age() {
            let a = this.aaw(this.aap);
            if (a == 1 || a == 5) {
                this.ahq = 0;
            }
            else {
                this.ahq = 2;
            }
            this.agd((b) => b.location = a);
        }
        aax(a) {
            if (a == 0) {
                return 2;
            }
            else if (a == 1) {
                return 3;
            }
            else if (a == 3) {
                return 7;
            }
            else if (a == 2) {
                return 6;
            }
            else {
                if (this.cb == 1) {
                    return 3;
                }
                else {
                    return 2;
                }
            }
        }
        aaw(a) {
            if (a == 1) {
                return 1;
            }
            else if (a == 0) {
                return 0;
            }
            else if (a == 3) {
                return 5;
            }
            else if (a == 2) {
                return 4;
            }
            else {
                return 1;
            }
        }
        get ade() {
            return this.adc;
        }
        set ade(a) {
            let b = this.ade;
            if (a != b) {
                this.adc = a;
                this.wd("AngleAxisLabel", b, this.ade);
            }
        }
        get adf() {
            return this.add;
        }
        set adf(a) {
            let b = this.adf;
            if (a != b) {
                this.add = a;
                this.wd("ValueAxisLabel", b, this.adf);
            }
        }
        get aha() {
            return this.agu;
        }
        set aha(a) {
            let b = this.aha;
            if (a != b) {
                this.agu = a;
                this.wd("AngleAxisMajorStroke", b, this.aha);
            }
        }
        get ahh() {
            return this.ag1;
        }
        set ahh(a) {
            let b = this.ahh;
            if (a != b) {
                this.ag1 = a;
                this.wd("ValueAxisMajorStroke", b, this.ahh);
            }
        }
        get acc() {
            return this.aba;
        }
        set acc(a) {
            let b = this.acc;
            if (a != b) {
                this.aba = a;
                this.wd("AngleAxisMajorStrokeThickness", b, this.acc);
            }
        }
        get acz() {
            return this.abt;
        }
        set acz(a) {
            let b = this.acz;
            if (a != b) {
                this.abt = a;
                this.wd("ValueAxisMajorStrokeThickness", b, this.acz);
            }
        }
        get acf() {
            return this.abd;
        }
        set acf(a) {
            let b = this.acf;
            if (a != b) {
                this.abd = a;
                this.wd("AngleAxisMinorStrokeThickness", b, this.acf);
            }
        }
        get ac2() {
            return this.abw;
        }
        set ac2(a) {
            let b = this.ac2;
            if (a != b) {
                this.abw = a;
                this.wd("ValueAxisMinorStrokeThickness", b, this.ac2);
            }
        }
        get ahc() {
            return this.agw;
        }
        set ahc(a) {
            let b = this.ahc;
            if (a != b) {
                this.agw = a;
                this.wd("AngleAxisStrip", b, this.ahc);
            }
        }
        get ahj() {
            return this.ag3;
        }
        set ahj(a) {
            let b = this.ahj;
            if (a != b) {
                this.ag3 = a;
                this.wd("ValueAxisStrip", b, this.ahj);
            }
        }
        get ahd() {
            return this.agx;
        }
        set ahd(a) {
            let b = this.ahd;
            if (a != b) {
                this.agx = a;
                this.wd("AngleAxisStroke", b, this.ahd);
            }
        }
        get ahk() {
            return this.ag4;
        }
        set ahk(a) {
            let b = this.ahk;
            if (a != b) {
                this.ag4 = a;
                this.wd("ValueAxisStroke", b, this.ahk);
            }
        }
        get acg() {
            return this.abe;
        }
        set acg(a) {
            let b = this.acg;
            if (a != b) {
                this.abe = a;
                this.wd("AngleAxisStrokeThickness", b, this.acg);
            }
        }
        get ac3() {
            return this.abx;
        }
        set ac3(a) {
            let b = this.ac3;
            if (a != b) {
                this.abx = a;
                this.wd("ValueAxisStrokeThickness", b, this.ac3);
            }
        }
        get ach() {
            return this.abf;
        }
        set ach(a) {
            let b = this.ach;
            if (a != b) {
                this.abf = a;
                this.wd("AngleAxisTickLength", b, this.ach);
            }
        }
        get ac4() {
            return this.aby;
        }
        set ac4(a) {
            let b = this.ac4;
            if (a != b) {
                this.aby = a;
                this.wd("ValueAxisTickLength", b, this.ac4);
            }
        }
        get ahe() {
            return this.agy;
        }
        set ahe(a) {
            let b = this.ahe;
            if (a != b) {
                this.agy = a;
                this.wd("AngleAxisTickStroke", b, this.ahe);
            }
        }
        get ahl() {
            return this.ag5;
        }
        set ahl(a) {
            let b = this.ahl;
            if (a != b) {
                this.ag5 = a;
                this.wd("ValueAxisTickStroke", b, this.ahl);
            }
        }
        get aci() {
            return this.abg;
        }
        set aci(a) {
            let b = this.aci;
            if (a != b) {
                this.abg = a;
                this.wd("AngleAxisTickStrokeThickness", b, this.aci);
            }
        }
        get ac5() {
            return this.abz;
        }
        set ac5(a) {
            let b = this.ac5;
            if (a != b) {
                this.abz = a;
                this.wd("ValueAxisTickStrokeThickness", b, this.ac5);
            }
        }
        get ael() {
            return this.adi;
        }
        set ael(a) {
            let b = this.ael;
            if (a != b) {
                this.adi = a;
                this.wd("AngleAxisTitle", b, this.ael);
            }
        }
        get aft() {
            return this.adm;
        }
        set aft(a) {
            let b = this.aft;
            if (a != b) {
                this.adm = a;
                this.wd("ValueAxisTitle", b, this.aft);
            }
        }
        get ahb() {
            return this.agv;
        }
        set ahb(a) {
            let b = this.ahb;
            if (a != b) {
                this.agv = a;
                this.wd("AngleAxisMinorStroke", b, this.ahb);
            }
        }
        get ahi() {
            return this.ag2;
        }
        set ahi(a) {
            let b = this.ahi;
            if (a != b) {
                this.ag2 = a;
                this.wd("ValueAxisMinorStroke", b, this.ahi);
            }
        }
        get ab7() {
            return this.aa5;
        }
        set ab7(a) {
            let b = this.ab7;
            if (a != b) {
                this.aa5 = a;
                this.wd("AngleAxisLabelAngle", b, this.ab7);
            }
        }
        get acu() {
            return this.abo;
        }
        set acu(a) {
            let b = this.acu;
            if (a != b) {
                this.abo = a;
                this.wd("ValueAxisLabelAngle", b, this.acu);
            }
        }
        get ab6() {
            return this.aa4;
        }
        set ab6(a) {
            let b = this.ab6;
            if (a != b) {
                this.aa4 = a;
                this.wd("AngleAxisExtent", b, this.ab6);
            }
        }
        get acd() {
            return this.abb;
        }
        set acd(a) {
            let b = this.acd;
            if (a != b) {
                this.abb = a;
                this.wd("AngleAxisMaximumExtent", b, this.acd);
            }
        }
        get ace() {
            return this.abc;
        }
        set ace(a) {
            let b = this.ace;
            if (a != b) {
                this.abc = a;
                this.wd("AngleAxisMaximumExtentPercentage", b, this.ace);
            }
        }
        get act() {
            return this.abn;
        }
        set act(a) {
            let b = this.act;
            if (a != b) {
                this.abn = a;
                this.wd("ValueAxisExtent", b, this.act);
            }
        }
        get ac0() {
            return this.abu;
        }
        set ac0(a) {
            let b = this.ac0;
            if (a != b) {
                this.abu = a;
                this.wd("ValueAxisMaximumExtent", b, this.ac0);
            }
        }
        get ac1() {
            return this.abv;
        }
        set ac1(a) {
            let b = this.ac1;
            if (a != b) {
                this.abv = a;
                this.wd("ValueAxisMaximumExtentPercentage", b, this.ac1);
            }
        }
        get acj() {
            return this.abh;
        }
        set acj(a) {
            let b = this.acj;
            if (a != b) {
                this.abh = a;
                this.wd("AngleAxisTitleAngle", b, this.acj);
            }
        }
        get ac6() {
            return this.ab0;
        }
        set ac6(a) {
            let b = this.ac6;
            if (a != b) {
                this.ab0 = a;
                this.wd("ValueAxisTitleAngle", b, this.ac6);
            }
        }
        get aa2() {
            return this.aa0;
        }
        set aa2(a) {
            let b = this.aa2;
            if (a != b) {
                this.aa0 = a;
                this.wd("AngleAxisInverted", b, this.aa2);
            }
        }
        get aa3() {
            return this.aa1;
        }
        set aa3(a) {
            let b = this.aa3;
            if (a != b) {
                this.aa1 = a;
                this.wd("ValueAxisInverted", b, this.aa3);
            }
        }
        get agp() {
            return this.agm;
        }
        set agp(a) {
            let b = this.agp;
            if (a != b) {
                this.agm = a;
                this.wd("AngleAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agp));
            }
        }
        get ahs() {
            return this.ahp;
        }
        set ahs(a) {
            let b = this.ahs;
            if (a != b) {
                this.ahp = a;
                this.wd("ValueAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahs));
            }
        }
        get ago() {
            return this.agl;
        }
        set ago(a) {
            let b = this.ago;
            if (a != b) {
                this.agl = a;
                this.wd("AngleAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ago));
            }
        }
        get_agq() {
            return this.agn;
        }
        set_agq(a) {
            let b = this.agq;
            if (a != b) {
                this.agn = a;
                this.wd("ValueAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agq));
            }
        }
        get agq() {
            return this.get_agq();
        }
        set agq(a) {
            this.set_agq(a);
        }
        get ahq() {
            return this.ahn;
        }
        set ahq(a) {
            let b = this.ahq;
            if (a != b) {
                this.ahn = a;
                this.wd("AngleAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahq));
            }
        }
        get ahr() {
            return this.aho;
        }
        set ahr(a) {
            let b = this.ahr;
            if (a != b) {
                this.aho = a;
                this.wd("ValueAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahr));
            }
        }
        get ahv() {
            return this.aht;
        }
        set ahv(a) {
            let b = this.ahv;
            if (a != b) {
                this.aht = a;
                this.wd("AngleAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ahv));
            }
        }
        get ahw() {
            return this.ahu;
        }
        set ahw(a) {
            let b = this.ahw;
            if (a != b) {
                this.ahu = a;
                this.wd("ValueAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ahw));
            }
        }
        get_aaz() {
            return this.aay;
        }
        set_aaz(a) {
            let b = this.aaz;
            if (a != b) {
                this.aay = a;
                this.wd("ValueAxisLabelLocation", enumGetBox(ValueAxisLabelLocation_$type, b), enumGetBox(ValueAxisLabelLocation_$type, this.aaz));
            }
        }
        get aaz() {
            return this.get_aaz();
        }
        set aaz(a) {
            this.set_aaz(a);
        }
        get_aap() {
            return this.aao;
        }
        set_aap(a) {
            let b = this.aap;
            if (a != b) {
                this.aao = a;
                this.wd("AngleAxisLabelLocation", enumGetBox(AngleAxisLabelLocation_$type, b), enumGetBox(AngleAxisLabelLocation_$type, this.aap));
            }
        }
        get aap() {
            return this.get_aap();
        }
        set aap(a) {
            this.set_aap(a);
        }
        get adv() {
            return this.adg;
        }
        set adv(a) {
            let b = this.adg;
            if (a != b) {
                this.adg = a;
                this.wd("AngleAxisLabelFormat", b, this.adg);
            }
        }
        get aam() {
            return this.aak;
        }
        set aam(a) {
            let b = this.aak;
            if (a != b) {
                this.aak = a;
                this.wd("AngleAxisLabelFormatSpecifiers", b, this.aak);
            }
        }
        get ae3() {
            return this.adk;
        }
        set ae3(a) {
            let b = this.adk;
            if (a != b) {
                this.adk = a;
                this.wd("ValueAxisLabelFormat", b, this.adk);
            }
        }
        get aan() {
            return this.aal;
        }
        set aan(a) {
            let b = this.aal;
            if (a != b) {
                this.aal = a;
                this.wd("ValueAxisLabelFormatSpecifiers", b, this.aal);
            }
        }
    }
    RadialBaseChart.$t = markType(RadialBaseChart, 'RadialBaseChart', DomainChart.$);
    return RadialBaseChart;
})();
