/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-angular-core";
import { HorizontalAlignment_$type } from "igniteui-angular-core";
import { VerticalAlignment_$type } from "igniteui-angular-core";
import { Visibility_$type } from "igniteui-angular-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-angular-core";
/**
 * @hidden
 */
export let XYChart = /*@__PURE__*/ (() => {
    class XYChart extends DomainChart {
        constructor() {
            super(...arguments);
            this.aaq = null;
            this.aar = null;
            this.aa7 = 0;
            this.aa9 = 5;
            this.aa8 = 0;
            this.aa6 = 5;
            this.abq = 5;
            this.abs = 0;
            this.abr = 5;
            this.abp = 0;
            this.agt = null;
            this.ag0 = null;
            this.agr = null;
            this.ags = null;
            this.abk = 0;
            this.ab3 = 0;
            this.abj = NaN;
            this.ab2 = NaN;
            this.abm = NaN;
            this.ab5 = NaN;
            this.abl = NaN;
            this.ab4 = NaN;
            this.abi = NaN;
            this.ab1 = NaN;
            this.agz = null;
            this.ag6 = null;
            this.adh = null;
            this.adl = null;
            this.adj = null;
            this.adn = null;
            this.adc = null;
            this.add = null;
            this.agu = null;
            this.ag1 = null;
            this.aba = DeviceUtils.g(1);
            this.abt = DeviceUtils.g(1);
            this.abd = DeviceUtils.g(1);
            this.abw = DeviceUtils.g(1);
            this.agw = null;
            this.ag3 = null;
            this.agx = null;
            this.ag4 = null;
            this.abe = DeviceUtils.g(1);
            this.abx = DeviceUtils.g(1);
            this.abf = DeviceUtils.g(8);
            this.aby = 0;
            this.agy = null;
            this.ag5 = null;
            this.abg = DeviceUtils.g(1);
            this.abz = DeviceUtils.g(1);
            this.adi = null;
            this.adm = null;
            this.agv = null;
            this.ag2 = null;
            this.aa5 = 0;
            this.abo = 0;
            this.aa4 = NaN;
            this.abn = NaN;
            this.abb = NaN;
            this.abu = NaN;
            this.abc = NaN;
            this.abv = NaN;
            this.abh = 0;
            this.ab0 = -90;
            this.aa0 = false;
            this.aa1 = false;
            this.agm = 1;
            this.ahp = 1;
            this.agl = 1;
            this.agn = 2;
            this.ahn = 0;
            this.aho = 1;
            this.aht = 0;
            this.ahu = 0;
            this.aay = 4;
            this.aaw = 4;
            this.adg = null;
            this.aak = null;
            this.adk = null;
            this.aal = null;
        }
        provideContainer(a) {
            if (a != null) {
                let b = this.aao();
                let c = this.aap();
                if (b != null) {
                    b.provideRenderer(a);
                }
                if (c != null) {
                    c.provideRenderer(a);
                }
            }
            super.provideContainer(a);
        }
        vm() {
            super.vm();
            let a = this.aao();
            let b = this.aap();
            if (a != null && a.az != null) {
                this.ag9 = a.az.textColor;
            }
            if (b != null && b.az != null) {
                this.ahg = b.az.textColor;
            }
            this.ahe = AxisDefaults.axis_TickBrush;
            this.ahl = AxisDefaults.axis_TickBrush;
            this.aha = AxisDefaults.axis_MajorBrush;
            this.ahh = AxisDefaults.axis_MajorBrush;
            this.ahd = AxisDefaults.axis_LineBrush;
            this.ahk = AxisDefaults.axis_LineBrush;
        }
        wh(a, b, c) {
            super.wh(a, b, c);
            switch (a) {
                case "XAxisLabelLeftMargin":
                    this.agd((d) => d.leftMargin = this.acd);
                    break;
                case "XAxisLabelTopMargin":
                    this.agd((d) => d.topMargin = this.acf);
                    break;
                case "XAxisLabelRightMargin":
                    this.agd((d) => d.rightMargin = this.ace);
                    break;
                case "XAxisLabelBottomMargin":
                    this.agd((d) => d.bottomMargin = this.acc);
                    break;
                case "YAxisLabelLeftMargin":
                    this.agi((d) => d.leftMargin = this.acw);
                    break;
                case "YAxisLabelTopMargin":
                    this.agi((d) => d.topMargin = this.acy);
                    break;
                case "YAxisLabelRightMargin":
                    this.agi((d) => d.rightMargin = this.acx);
                    break;
                case "YAxisLabelBottomMargin":
                    this.agi((d) => d.bottomMargin = this.acv);
                    break;
                case "ActualItemsSource":
                case "ShouldDisplayMockData":
                case "ShouldUseSkeletonStyleForMockData":
                    this.ag7 = this.zi(this.ag9);
                    this.ag8 = this.zi(this.ahg);
                    break;
                case "XAxisLabelTextColor":
                    this.ag7 = this.zi(this.ag9);
                    break;
                case "YAxisLabelTextColor":
                    this.ag8 = this.zi(this.ahg);
                    break;
                case "ActualXAxisLabelTextColor":
                    this.agd((d) => d.textColor = this.ag7);
                    break;
                case "ActualYAxisLabelTextColor":
                    this.agi((d) => d.textColor = this.ag8);
                    break;
                case "XAxisTitleMargin":
                    this.agf((d) => d.margin = this.acq);
                    break;
                case "YAxisTitleMargin":
                    this.agk((d) => d.margin = this.ac9);
                    break;
                case "XAxisTitleLeftMargin":
                    this.agf((d) => d.leftMargin = this.acp);
                    break;
                case "YAxisTitleLeftMargin":
                    this.agk((d) => d.leftMargin = this.ac8);
                    break;
                case "XAxisTitleTopMargin":
                    this.agf((d) => d.topMargin = this.acs);
                    break;
                case "YAxisTitleTopMargin":
                    this.agk((d) => d.topMargin = this.adb);
                    break;
                case "XAxisTitleRightMargin":
                    this.agf((d) => d.rightMargin = this.acr);
                    break;
                case "YAxisTitleRightMargin":
                    this.agk((d) => d.rightMargin = this.ada);
                    break;
                case "XAxisTitleBottomMargin":
                    this.agf((d) => d.bottomMargin = this.aco);
                    break;
                case "YAxisTitleBottomMargin":
                    this.agk((d) => d.bottomMargin = this.ac7);
                    break;
                case "XAxisTitleTextColor":
                    this.agf((d) => d.textColor = this.ahf);
                    break;
                case "YAxisTitleTextColor":
                    this.agk((d) => d.textColor = this.ahm);
                    break;
                case "XAxisFormatLabel":
                    this.agb((d) => d.au = this.aas);
                    break;
                case "YAxisFormatLabel":
                    this.agg((d) => d.au = this.aat);
                    break;
            }
        }
        get aas() {
            return this.aaq;
        }
        set aas(a) {
            let b = this.aas;
            if (a != b) {
                this.aaq = a;
                this.wd("XAxisFormatLabel", b, this.aas);
            }
        }
        get aat() {
            return this.aar;
        }
        set aat(a) {
            let b = this.aat;
            if (a != b) {
                this.aar = a;
                this.wd("YAxisFormatLabel", b, this.aat);
            }
        }
        get acd() {
            return this.aa7;
        }
        set acd(a) {
            let b = this.acd;
            if (a != b) {
                this.aa7 = a;
                this.wd("XAxisLabelLeftMargin", b, this.acd);
            }
        }
        get acf() {
            return this.aa9;
        }
        set acf(a) {
            let b = this.acf;
            if (a != b) {
                this.aa9 = a;
                this.wd("XAxisLabelTopMargin", b, this.acf);
            }
        }
        get ace() {
            return this.aa8;
        }
        set ace(a) {
            let b = this.ace;
            if (a != b) {
                this.aa8 = a;
                this.wd("XAxisLabelRightMargin", b, this.ace);
            }
        }
        get acc() {
            return this.aa6;
        }
        set acc(a) {
            let b = this.acc;
            if (a != b) {
                this.aa6 = a;
                this.wd("XAxisLabelBottomMargin", b, this.acc);
            }
        }
        get acw() {
            return this.abq;
        }
        set acw(a) {
            let b = this.acw;
            if (a != b) {
                this.abq = a;
                this.wd("YAxisLabelLeftMargin", b, this.acw);
            }
        }
        get acy() {
            return this.abs;
        }
        set acy(a) {
            let b = this.acy;
            if (a != b) {
                this.abs = a;
                this.wd("YAxisLabelTopMargin", b, this.acy);
            }
        }
        get acx() {
            return this.abr;
        }
        set acx(a) {
            let b = this.acx;
            if (a != b) {
                this.abr = a;
                this.wd("YAxisLabelRightMargin", b, this.acx);
            }
        }
        get acv() {
            return this.abp;
        }
        set acv(a) {
            let b = this.acv;
            if (a != b) {
                this.abp = a;
                this.wd("YAxisLabelBottomMargin", b, this.acv);
            }
        }
        get ag9() {
            return this.agt;
        }
        set ag9(a) {
            let b = this.ag9;
            if (a != b) {
                this.agt = a;
                this.wd("XAxisLabelTextColor", b, this.ag9);
            }
        }
        get ahg() {
            return this.ag0;
        }
        set ahg(a) {
            let b = this.ahg;
            if (a != b) {
                this.ag0 = a;
                this.wd("YAxisLabelTextColor", b, this.ahg);
            }
        }
        get ag7() {
            return this.agr;
        }
        set ag7(a) {
            let b = this.agr;
            if (a != b) {
                this.agr = a;
                this.wd("ActualXAxisLabelTextColor", b, this.ag7);
            }
        }
        get ag8() {
            return this.ags;
        }
        set ag8(a) {
            let b = this.ags;
            if (a != b) {
                this.ags = a;
                this.wd("ActualYAxisLabelTextColor", b, this.ag8);
            }
        }
        get acq() {
            return this.abk;
        }
        set acq(a) {
            let b = this.acq;
            if (a != b) {
                this.abk = a;
                this.wd("XAxisTitleMargin", b, this.acq);
            }
        }
        get ac9() {
            return this.ab3;
        }
        set ac9(a) {
            let b = this.ac9;
            if (a != b) {
                this.ab3 = a;
                this.wd("YAxisTitleMargin", b, this.ac9);
            }
        }
        get acp() {
            return this.abj;
        }
        set acp(a) {
            let b = this.acp;
            if (a != b) {
                this.abj = a;
                this.wd("XAxisTitleLeftMargin", b, this.acp);
            }
        }
        get ac8() {
            return this.ab2;
        }
        set ac8(a) {
            let b = this.ac8;
            if (a != b) {
                this.ab2 = a;
                this.wd("YAxisTitleLeftMargin", b, this.ac8);
            }
        }
        get acs() {
            return this.abm;
        }
        set acs(a) {
            let b = this.acs;
            if (a != b) {
                this.abm = a;
                this.wd("XAxisTitleTopMargin", b, this.acs);
            }
        }
        get adb() {
            return this.ab5;
        }
        set adb(a) {
            let b = this.adb;
            if (a != b) {
                this.ab5 = a;
                this.wd("YAxisTitleTopMargin", b, this.adb);
            }
        }
        get acr() {
            return this.abl;
        }
        set acr(a) {
            let b = this.acr;
            if (a != b) {
                this.abl = a;
                this.wd("XAxisTitleRightMargin", b, this.acr);
            }
        }
        get ada() {
            return this.ab4;
        }
        set ada(a) {
            let b = this.ada;
            if (a != b) {
                this.ab4 = a;
                this.wd("YAxisTitleRightMargin", b, this.ada);
            }
        }
        get aco() {
            return this.abi;
        }
        set aco(a) {
            let b = this.aco;
            if (a != b) {
                this.abi = a;
                this.wd("XAxisTitleBottomMargin", b, this.aco);
            }
        }
        get ac7() {
            return this.ab1;
        }
        set ac7(a) {
            let b = this.ac7;
            if (a != b) {
                this.ab1 = a;
                this.wd("YAxisTitleBottomMargin", b, this.ac7);
            }
        }
        get ahf() {
            return this.agz;
        }
        set ahf(a) {
            let b = this.ahf;
            if (a != b) {
                this.agz = a;
                this.wd("XAxisTitleTextColor", b, this.ahf);
            }
        }
        get ahm() {
            return this.ag6;
        }
        set ahm(a) {
            let b = this.ahm;
            if (a != b) {
                this.ag6 = a;
                this.wd("YAxisTitleTextColor", b, this.ahm);
            }
        }
        wi(a, b, c) {
            super.wi(a, b, c);
            switch (a) {
                case "XAxisLabelTextStyle":
                    this.agd((d) => d.textStyle = this.ad5);
                    break;
                case "YAxisLabelTextStyle":
                    this.agi((d) => d.textStyle = this.afc);
                    break;
                case "XAxisTitleTextStyle":
                    this.agf((d) => d.textStyle = this.aev);
                    break;
                case "YAxisTitleTextStyle":
                    this.agk((d) => d.textStyle = this.af2);
                    break;
            }
        }
        get ad5() {
            return this.adh;
        }
        set ad5(a) {
            let b = this.ad5;
            if (a != b) {
                this.adh = a;
                this.wd("XAxisLabelTextStyle", b, this.ad5);
            }
        }
        get afc() {
            return this.adl;
        }
        set afc(a) {
            let b = this.afc;
            if (a != b) {
                this.adl = a;
                this.wd("YAxisLabelTextStyle", b, this.afc);
            }
        }
        get aev() {
            return this.adj;
        }
        set aev(a) {
            let b = this.aev;
            if (a != b) {
                this.adj = a;
                this.wd("XAxisTitleTextStyle", b, this.aev);
            }
        }
        get af2() {
            return this.adn;
        }
        set af2(a) {
            let b = this.af2;
            if (a != b) {
                this.adn = a;
                this.wd("YAxisTitleTextStyle", b, this.af2);
            }
        }
        af8(a) {
            this.af5(a, (b) => b.leftMargin = this.acd);
            this.af5(a, (b) => b.topMargin = this.acf);
            this.af5(a, (b) => b.rightMargin = this.ace);
            this.af5(a, (b) => b.bottomMargin = this.acc);
            this.af5(a, (b) => b.textColor = this.ag7);
            this.af6(a, (b) => b.textColor = this.ahf);
            this.af6(a, (b) => b.leftMargin = this.acp);
            this.af6(a, (b) => b.topMargin = this.acs);
            this.af6(a, (b) => b.rightMargin = this.acr);
            this.af6(a, (b) => b.bottomMargin = this.aco);
            this.af5(a, (b) => b.textStyle = this.ad5);
            this.af6(a, (b) => b.textStyle = this.aev);
        }
        aga(a) {
            this.af5(a, (b) => b.leftMargin = this.acw);
            this.af5(a, (b) => b.topMargin = this.acy);
            this.af5(a, (b) => b.rightMargin = this.acx);
            this.af5(a, (b) => b.bottomMargin = this.acv);
            this.af5(a, (b) => b.textColor = this.ag8);
            this.af6(a, (b) => b.textColor = this.ahm);
            this.af6(a, (b) => b.leftMargin = this.ac8);
            this.af6(a, (b) => b.topMargin = this.adb);
            this.af6(a, (b) => b.rightMargin = this.ada);
            this.af6(a, (b) => b.bottomMargin = this.ac7);
            this.af5(a, (b) => b.textStyle = this.afc);
            this.af6(a, (b) => b.textStyle = this.af2);
        }
        w9(a) {
            let b = this.be(a);
            let c = this.dc(a, b);
            if (c == null) {
                return;
            }
            c.itemsSource = this.h6(a);
            if (a.highlightedData != null) {
                c.highlightedItemsSource = this.h7(a);
            }
            c.name = this.q0(a);
            c.title = this.q1(a, b);
            this.dataChart.series.add(c);
        }
        agb(a) {
            this.agc(a, null);
        }
        agc(a, b) {
            a(this.aao());
        }
        agh(a, b) {
            a(this.aap());
        }
        agg(a) {
            this.agh(a, true);
        }
        u5(a, b) {
            this.agb(a);
            this.agh(a, b);
        }
        agf(a) {
            this.af6(this.aao(), a);
        }
        agk(a) {
            this.af6(this.aap(), a);
        }
        agi(a) {
            this.af5(this.aap(), a);
        }
        agd(a) {
            this.af5(this.aao(), a);
        }
        ab6(a) {
            let b = this.aao();
            return b.el(a, new ScalerParams(1, this.zr, this.zq, b.ch));
        }
        ab8(a) {
            let b = this.aao();
            return b.eo(a, new ScalerParams(1, this.zr, this.zq, b.ch));
        }
        ab7(a) {
            let b = this.aap();
            return b.el(a, new ScalerParams(1, this.zr, this.zq, b.ch));
        }
        ab9(a) {
            let b = this.aap();
            return b.eo(a, new ScalerParams(1, this.zr, this.zq, b.ch));
        }
        w6(a) {
            super.w6(a);
            if (a == null) {
                return;
            }
            if (a.axes != null) {
                let b = this.aao();
                let c = this.aap();
                if (a.axes.contains(b)) {
                    a.axes.remove(b);
                }
                if (a.axes.contains(c)) {
                    a.axes.remove(c);
                }
            }
        }
        static adq(a, b) {
            for (let c of fromEnum(b)) {
                let d = c.findMatchingHint(16);
                if (d != null) {
                    let e = d.path;
                    return e;
                }
            }
            return null;
        }
        vh(a, b) {
            super.vh(a, b);
            if (a == this.dataChart) {
                this.dataChart.axes.add(this.aao());
                this.dataChart.axes.add(this.aap());
            }
        }
        af7(a) {
            if (a != null && this.l4 != null && a.fn == null) {
                a.provideRenderer(this.l4);
            }
            a.jz = this.aha;
            a.et = this.acg;
            a.j0 = this.ahb;
            a.ew = this.acj;
            a.j2 = this.ahd;
            a.fi = this.ack;
            a.j1 = this.ahc;
            a.fj = this.acl;
            a.j3 = this.ahe;
            a.fk = this.acm;
            a.c4 = true;
            a.cu = this.shouldAvoidAxisAnnotationCollisions;
            a.cw = this.shouldAvoidAxisAnnotationCollisions;
            let b = a == this.aao();
            if (b) {
                a.g8 = this.aem;
            }
            a.f2 = this.ade;
            a.gi = this.adw;
            a.ah = this.aam;
            this.af5(a, (c) => c.angle = this.acb);
            this.af5(a, (c) => {
                if (c.extent != this.aca) {
                    c.extent = this.aca;
                }
            });
            this.af5(a, (c) => {
                if (c.maximumExtent != this.ach) {
                    c.maximumExtent = this.ach;
                }
            });
            this.af5(a, (c) => {
                if (c.maximumExtentPercentage != this.aci) {
                    c.maximumExtentPercentage = this.aci;
                }
            });
            this.af5(a, (c) => c.horizontalAlignment = this.ago);
            this.af5(a, (c) => c.verticalAlignment = this.ahq);
            this.af5(a, (c) => c.visibility = this.ahv);
            this.af5(a, (c) => c.location = this.aau(this.aax));
            this.af6(a, (c) => c.horizontalAlignment = this.agp);
            this.af6(a, (c) => c.angle = this.acn);
            this.af8(a);
        }
        af9(a) {
            if (a == null) {
                return;
            }
            if (this.l4 != null && a.fn == null) {
                a.provideRenderer(this.l4);
            }
            a.cu = this.shouldAvoidAxisAnnotationCollisions;
            a.cw = this.shouldAvoidAxisAnnotationCollisions;
            this.af5(a, (b) => b.angle = this.acu);
            this.af5(a, (b) => {
                if (b.extent != this.act) {
                    b.extent = this.act;
                }
            });
            this.af5(a, (b) => {
                if (b.maximumExtent != this.ac0) {
                    b.maximumExtent = this.ac0;
                }
            });
            this.af5(a, (b) => {
                if (b.maximumExtentPercentage != this.ac1) {
                    b.maximumExtentPercentage = this.ac1;
                }
            });
            this.af5(a, (b) => b.horizontalAlignment = this.agq);
            this.af5(a, (b) => b.verticalAlignment = this.ahr);
            this.af5(a, (b) => b.visibility = this.ahw);
            this.af5(a, (b) => b.location = this.aav(this.aaz));
            this.af6(a, (b) => b.verticalAlignment = this.ahs);
            this.af6(a, (b) => b.angle = this.ac6);
            a.jz = this.ahh;
            a.et = this.acz;
            a.j0 = this.ahi;
            a.ew = this.ac2;
            a.j2 = this.ahk;
            a.fi = this.ac3;
            a.j1 = this.ahj;
            a.fj = this.ac4;
            a.j3 = this.ahl;
            a.fk = this.ac5;
            let b = a == this.aap();
            if (b) {
                a.g8 = this.aft;
            }
            a.gi = this.ae3;
            a.ah = this.aan;
            this.aga(a);
        }
        ve() {
            super.ve();
            this.af7(this.aao());
            this.af9(this.aap());
        }
        af5(a, b) {
            if (a == null) {
                return;
            }
            if (a.az == null) {
                a.az = new AxisLabelSettings();
                a.az.angle = a.d7();
                a.az.bottomMargin = a.d8();
                a.az.leftMargin = a.d9();
                a.az.rightMargin = a.ea();
                a.az.topMargin = a.eb();
                a.az.horizontalAlignment = a.ju();
                a.az.location = a.a0();
                a.az.verticalAlignment = a.ko();
            }
            b(a.az);
        }
        af6(a, b) {
            if (a == null) {
                return;
            }
            if (a.bf == null) {
                a.bf = new TitleSettings();
                a.bf.bottomMargin = a.ed();
                a.bf.leftMargin = a.ee();
                a.bf.rightMargin = a.ef();
                a.bf.topMargin = a.eg();
                a.bf.location = a.a1();
                a.bf.angle = a.ec();
                a.bf.horizontalAlignment = a.jv();
                a.bf.verticalAlignment = a.kp();
            }
            b(a.bf);
        }
        wd(a, b, c) {
            super.wd(a, b, c);
            switch (a) {
                case "XAxisLabelAngle":
                    this.agd((d) => d.angle = this.acb);
                    break;
                case "YAxisLabelAngle":
                    this.agi((d) => d.angle = this.acu);
                    break;
                case "XAxisLabelHorizontalAlignment":
                    this.agd((d) => d.horizontalAlignment = this.ago);
                    break;
                case "YAxisLabelHorizontalAlignment":
                    this.agi((d) => d.horizontalAlignment = this.agq);
                    break;
                case "XAxisLabelVerticalAlignment":
                    this.agd((d) => d.verticalAlignment = this.ahq);
                    break;
                case "YAxisLabelVerticalAlignment":
                    this.agi((d) => d.verticalAlignment = this.ahr);
                    break;
                case "XAxisLabelVisibility":
                    this.agd((d) => d.visibility = this.ahv);
                    break;
                case "YAxisLabelVisibility":
                    this.agi((d) => d.visibility = this.ahw);
                    break;
                case "XAxisLabel":
                    this.agb((d) => d.f2 = this.ade);
                    break;
                case "YAxisLabel":
                    this.agg((d) => d.f2 = this.adf);
                    break;
                case "XAxisLabelFormat":
                    this.agb((d) => d.gi = this.adw);
                    break;
                case "XAxisLabelFormatSpecifiers":
                    this.agb((d) => d.ah = this.aam);
                    break;
                case "YAxisLabelFormat":
                    this.agg((d) => d.gi = this.ae3);
                    break;
                case "YAxisLabelFormatSpecifiers":
                    this.agg((d) => d.ah = this.aan);
                    break;
                case "XAxisTitleAngle":
                    this.agf((d) => d.angle = this.acn);
                    break;
                case "YAxisTitleAngle":
                    this.agk((d) => d.angle = this.ac6);
                    break;
                case "XAxisTitleAlignment":
                    this.agf((d) => d.horizontalAlignment = this.agp);
                    break;
                case "YAxisTitleAlignment":
                    this.agk((d) => d.verticalAlignment = this.ahs);
                    break;
                case "XAxisTitle":
                    this.agb((d) => d.g8 = this.aem);
                    break;
                case "YAxisTitle":
                    this.agh((d) => d.g8 = this.aft, false);
                    break;
                case "XAxisMajorStroke":
                    this.agc((d) => d.jz = this.aha, a);
                    break;
                case "YAxisMajorStroke":
                    this.agg((d) => d.jz = this.ahh);
                    break;
                case "XAxisMajorStrokeThickness":
                    this.agc((d) => d.et = this.acg, a);
                    break;
                case "YAxisMajorStrokeThickness":
                    this.agg((d) => d.et = this.acz);
                    break;
                case "XAxisMinorStroke":
                    this.agb((d) => d.j0 = this.ahb);
                    break;
                case "YAxisMinorStroke":
                    this.agg((d) => d.j0 = this.ahi);
                    break;
                case "XAxisMinorStrokeThickness":
                    this.agb((d) => d.ew = this.acj);
                    break;
                case "YAxisMinorStrokeThickness":
                    this.agg((d) => d.ew = this.ac2);
                    break;
                case "XAxisTickLength":
                    this.agb((d) => d.fj = this.acl);
                    break;
                case "YAxisTickLength":
                    this.agg((d) => d.fj = this.ac4);
                    break;
                case "XAxisTickStroke":
                    this.agb((d) => d.j3 = this.ahe);
                    break;
                case "YAxisTickStroke":
                    this.agg((d) => d.j3 = this.ahl);
                    break;
                case "XAxisTickStrokeThickness":
                    this.agb((d) => d.fk = this.acm);
                    break;
                case "YAxisTickStrokeThickness":
                    this.agg((d) => d.fk = this.ac5);
                    break;
                case "XAxisStroke":
                    this.agb((d) => d.j2 = this.ahd);
                    break;
                case "YAxisStroke":
                    this.agg((d) => d.j2 = this.ahk);
                    break;
                case "XAxisStrokeThickness":
                    this.agb((d) => d.fi = this.ack);
                    break;
                case "YAxisStrokeThickness":
                    this.agg((d) => d.fi = this.ac3);
                    break;
                case "XAxisExtent":
                    this.agd((d) => d.extent = this.aca);
                    break;
                case "YAxisExtent":
                    this.agi((d) => d.extent = this.act);
                    break;
                case "XAxisMaximumExtent":
                    this.agd((d) => d.maximumExtent = this.ach);
                    break;
                case "YAxisMaximumExtent":
                    this.agi((d) => d.maximumExtent = this.ac0);
                    break;
                case "XAxisMaximumExtentPercentage":
                    this.agd((d) => d.maximumExtentPercentage = this.aci);
                    break;
                case "YAxisMaximumExtentPercentage":
                    this.agi((d) => d.maximumExtentPercentage = this.ac1);
                    break;
                case "XAxisStrip":
                    this.agb((d) => d.j1 = this.ahc);
                    break;
                case "YAxisStrip":
                    this.agg((d) => d.j1 = this.ahj);
                    break;
                case "XAxisInverted":
                    this.agb((d) => d.ch = this.aa2);
                    break;
                case "YAxisInverted":
                    this.agg((d) => d.ch = this.aa3);
                    break;
                case "YAxisLabelLocation":
                    this.agj();
                    break;
                case "XAxisLabelLocation":
                    this.age();
                    break;
            }
        }
        agj() {
            let a = this.aav(this.aaz);
            if (a == 2 || a == 7) {
                this.agq = 2;
            }
            else {
                this.agq = 0;
            }
            this.agi((b) => b.location = a);
        }
        age() {
            let a = this.aau(this.aax);
            if (a == 1 || a == 5) {
                this.ahq = 0;
            }
            else {
                this.ahq = 2;
            }
            this.agd((b) => b.location = a);
        }
        aav(a) {
            if (a == 0) {
                return 2;
            }
            else if (a == 1) {
                return 3;
            }
            else if (a == 3) {
                return 7;
            }
            else if (a == 2) {
                return 6;
            }
            else {
                if (this.cb == 1) {
                    return 3;
                }
                else {
                    return 2;
                }
            }
        }
        aau(a) {
            if (a == 1) {
                return 1;
            }
            else if (a == 0) {
                return 0;
            }
            else if (a == 3) {
                return 5;
            }
            else if (a == 2) {
                return 4;
            }
            else {
                return 1;
            }
        }
        get ade() {
            return this.adc;
        }
        set ade(a) {
            let b = this.ade;
            if (a != b) {
                this.adc = a;
                this.wd("XAxisLabel", b, this.ade);
            }
        }
        get adf() {
            return this.add;
        }
        set adf(a) {
            let b = this.adf;
            if (a != b) {
                this.add = a;
                this.wd("YAxisLabel", b, this.adf);
            }
        }
        get aha() {
            return this.agu;
        }
        set aha(a) {
            let b = this.aha;
            if (a != b) {
                this.agu = a;
                this.wd("XAxisMajorStroke", b, this.aha);
            }
        }
        get ahh() {
            return this.ag1;
        }
        set ahh(a) {
            let b = this.ahh;
            if (a != b) {
                this.ag1 = a;
                this.wd("YAxisMajorStroke", b, this.ahh);
            }
        }
        get acg() {
            return this.aba;
        }
        set acg(a) {
            let b = this.acg;
            if (a != b) {
                this.aba = a;
                this.wd("XAxisMajorStrokeThickness", b, this.acg);
            }
        }
        get acz() {
            return this.abt;
        }
        set acz(a) {
            let b = this.acz;
            if (a != b) {
                this.abt = a;
                this.wd("YAxisMajorStrokeThickness", b, this.acz);
            }
        }
        get acj() {
            return this.abd;
        }
        set acj(a) {
            let b = this.acj;
            if (a != b) {
                this.abd = a;
                this.wd("XAxisMinorStrokeThickness", b, this.acj);
            }
        }
        get ac2() {
            return this.abw;
        }
        set ac2(a) {
            let b = this.ac2;
            if (a != b) {
                this.abw = a;
                this.wd("YAxisMinorStrokeThickness", b, this.ac2);
            }
        }
        get ahc() {
            return this.agw;
        }
        set ahc(a) {
            let b = this.ahc;
            if (a != b) {
                this.agw = a;
                this.wd("XAxisStrip", b, this.ahc);
            }
        }
        get ahj() {
            return this.ag3;
        }
        set ahj(a) {
            let b = this.ahj;
            if (a != b) {
                this.ag3 = a;
                this.wd("YAxisStrip", b, this.ahj);
            }
        }
        get ahd() {
            return this.agx;
        }
        set ahd(a) {
            let b = this.ahd;
            if (a != b) {
                this.agx = a;
                this.wd("XAxisStroke", b, this.ahd);
            }
        }
        get ahk() {
            return this.ag4;
        }
        set ahk(a) {
            let b = this.ahk;
            if (a != b) {
                this.ag4 = a;
                this.wd("YAxisStroke", b, this.ahk);
            }
        }
        get ack() {
            return this.abe;
        }
        set ack(a) {
            let b = this.ack;
            if (a != b) {
                this.abe = a;
                this.wd("XAxisStrokeThickness", b, this.ack);
            }
        }
        get ac3() {
            return this.abx;
        }
        set ac3(a) {
            let b = this.ac3;
            if (a != b) {
                this.abx = a;
                this.wd("YAxisStrokeThickness", b, this.ac3);
            }
        }
        get acl() {
            return this.abf;
        }
        set acl(a) {
            let b = this.acl;
            if (a != b) {
                this.abf = a;
                this.wd("XAxisTickLength", b, this.acl);
            }
        }
        get ac4() {
            return this.aby;
        }
        set ac4(a) {
            let b = this.ac4;
            if (a != b) {
                this.aby = a;
                this.wd("YAxisTickLength", b, this.ac4);
            }
        }
        get ahe() {
            return this.agy;
        }
        set ahe(a) {
            let b = this.ahe;
            if (a != b) {
                this.agy = a;
                this.wd("XAxisTickStroke", b, this.ahe);
            }
        }
        get ahl() {
            return this.ag5;
        }
        set ahl(a) {
            let b = this.ahl;
            if (a != b) {
                this.ag5 = a;
                this.wd("YAxisTickStroke", b, this.ahl);
            }
        }
        get acm() {
            return this.abg;
        }
        set acm(a) {
            let b = this.acm;
            if (a != b) {
                this.abg = a;
                this.wd("XAxisTickStrokeThickness", b, this.acm);
            }
        }
        get ac5() {
            return this.abz;
        }
        set ac5(a) {
            let b = this.ac5;
            if (a != b) {
                this.abz = a;
                this.wd("YAxisTickStrokeThickness", b, this.ac5);
            }
        }
        get aem() {
            return this.adi;
        }
        set aem(a) {
            let b = this.aem;
            if (a != b) {
                this.adi = a;
                this.wd("XAxisTitle", b, this.aem);
            }
        }
        get aft() {
            return this.adm;
        }
        set aft(a) {
            let b = this.aft;
            if (a != b) {
                this.adm = a;
                this.wd("YAxisTitle", b, this.aft);
            }
        }
        get ahb() {
            return this.agv;
        }
        set ahb(a) {
            let b = this.ahb;
            if (a != b) {
                this.agv = a;
                this.wd("XAxisMinorStroke", b, this.ahb);
            }
        }
        get ahi() {
            return this.ag2;
        }
        set ahi(a) {
            let b = this.ahi;
            if (a != b) {
                this.ag2 = a;
                this.wd("YAxisMinorStroke", b, this.ahi);
            }
        }
        get acb() {
            return this.aa5;
        }
        set acb(a) {
            let b = this.acb;
            if (a != b) {
                this.aa5 = a;
                this.wd("XAxisLabelAngle", b, this.acb);
            }
        }
        get acu() {
            return this.abo;
        }
        set acu(a) {
            let b = this.acu;
            if (a != b) {
                this.abo = a;
                this.wd("YAxisLabelAngle", b, this.acu);
            }
        }
        get aca() {
            return this.aa4;
        }
        set aca(a) {
            let b = this.aca;
            if (a != b) {
                this.aa4 = a;
                this.wd("XAxisExtent", b, this.aca);
            }
        }
        get act() {
            return this.abn;
        }
        set act(a) {
            let b = this.act;
            if (a != b) {
                this.abn = a;
                this.wd("YAxisExtent", b, this.act);
            }
        }
        get ach() {
            return this.abb;
        }
        set ach(a) {
            let b = this.ach;
            if (a != b) {
                this.abb = a;
                this.wd("XAxisMaximumExtent", b, this.ach);
            }
        }
        get ac0() {
            return this.abu;
        }
        set ac0(a) {
            let b = this.ac0;
            if (a != b) {
                this.abu = a;
                this.wd("YAxisMaximumExtent", b, this.ac0);
            }
        }
        get aci() {
            return this.abc;
        }
        set aci(a) {
            let b = this.aci;
            if (a != b) {
                this.abc = a;
                this.wd("XAxisMaximumExtentPercentage", b, this.aci);
            }
        }
        get ac1() {
            return this.abv;
        }
        set ac1(a) {
            let b = this.ac1;
            if (a != b) {
                this.abv = a;
                this.wd("YAxisMaximumExtentPercentage", b, this.ac1);
            }
        }
        get acn() {
            return this.abh;
        }
        set acn(a) {
            let b = this.acn;
            if (a != b) {
                this.abh = a;
                this.wd("XAxisTitleAngle", b, this.acn);
            }
        }
        get ac6() {
            return this.ab0;
        }
        set ac6(a) {
            let b = this.ac6;
            if (a != b) {
                this.ab0 = a;
                this.wd("YAxisTitleAngle", b, this.ac6);
            }
        }
        get aa2() {
            return this.aa0;
        }
        set aa2(a) {
            let b = this.aa2;
            if (a != b) {
                this.aa0 = a;
                this.wd("XAxisInverted", b, this.aa2);
            }
        }
        get aa3() {
            return this.aa1;
        }
        set aa3(a) {
            let b = this.aa3;
            if (a != b) {
                this.aa1 = a;
                this.wd("YAxisInverted", b, this.aa3);
            }
        }
        get agp() {
            return this.agm;
        }
        set agp(a) {
            let b = this.agp;
            if (a != b) {
                this.agm = a;
                this.wd("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agp));
            }
        }
        get ahs() {
            return this.ahp;
        }
        set ahs(a) {
            let b = this.ahs;
            if (a != b) {
                this.ahp = a;
                this.wd("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahs));
            }
        }
        get ago() {
            return this.agl;
        }
        set ago(a) {
            let b = this.ago;
            if (a != b) {
                this.agl = a;
                this.wd("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ago));
            }
        }
        get_agq() {
            return this.agn;
        }
        set_agq(a) {
            let b = this.agq;
            if (a != b) {
                this.agn = a;
                this.wd("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agq));
            }
        }
        get agq() {
            return this.get_agq();
        }
        set agq(a) {
            this.set_agq(a);
        }
        get ahq() {
            return this.ahn;
        }
        set ahq(a) {
            let b = this.ahq;
            if (a != b) {
                this.ahn = a;
                this.wd("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahq));
            }
        }
        get ahr() {
            return this.aho;
        }
        set ahr(a) {
            let b = this.ahr;
            if (a != b) {
                this.aho = a;
                this.wd("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahr));
            }
        }
        get ahv() {
            return this.aht;
        }
        set ahv(a) {
            let b = this.ahv;
            if (a != b) {
                this.aht = a;
                this.wd("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ahv));
            }
        }
        get ahw() {
            return this.ahu;
        }
        set ahw(a) {
            let b = this.ahw;
            if (a != b) {
                this.ahu = a;
                this.wd("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ahw));
            }
        }
        get_aaz() {
            return this.aay;
        }
        set_aaz(a) {
            let b = this.aaz;
            if (a != b) {
                this.aay = a;
                this.wd("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.aaz));
            }
        }
        get aaz() {
            return this.get_aaz();
        }
        set aaz(a) {
            this.set_aaz(a);
        }
        get_aax() {
            return this.aaw;
        }
        set_aax(a) {
            let b = this.aax;
            if (a != b) {
                this.aaw = a;
                this.wd("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.aax));
            }
        }
        get aax() {
            return this.get_aax();
        }
        set aax(a) {
            this.set_aax(a);
        }
        get adw() {
            return this.adg;
        }
        set adw(a) {
            let b = this.adg;
            if (a != b) {
                this.adg = a;
                this.wd("XAxisLabelFormat", b, this.adg);
            }
        }
        get aam() {
            return this.aak;
        }
        set aam(a) {
            let b = this.aak;
            if (a != b) {
                this.aak = a;
                this.wd("XAxisLabelFormatSpecifiers", b, this.aak);
            }
        }
        get ae3() {
            return this.adk;
        }
        set ae3(a) {
            let b = this.adk;
            if (a != b) {
                this.adk = a;
                this.wd("YAxisLabelFormat", b, this.adk);
            }
        }
        get aan() {
            return this.aal;
        }
        set aan(a) {
            let b = this.aal;
            if (a != b) {
                this.aal = a;
                this.wd("YAxisLabelFormatSpecifiers", b, this.aal);
            }
        }
    }
    XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
})();
