import { Component, Input } from '@angular/core';
import { IgxDataAnnotationShapeLayerComponent } from "./igx-data-annotation-shape-layer-component";
import { brushToString, stringToBrush } from "igniteui-angular-core";
import * as i0 from "@angular/core";
/**
 * Represents a base of annotation layers that render from start/end range
*/
export let IgxDataAnnotationRangeLayerComponent = /*@__PURE__*/ (() => {
    class IgxDataAnnotationRangeLayerComponent extends IgxDataAnnotationShapeLayerComponent {
        constructor() {
            super();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        /**
         * Gets or sets the text color used for displaying the start annotation label.
        */
        get startLabelTextColor() {
            return brushToString(this.i.af9);
        }
        set startLabelTextColor(v) {
            this.i.af9 = stringToBrush(v);
        }
        /**
         * Gets or sets the background used for displaying the start annotation label.
        */
        get startLabelBackground() {
            return brushToString(this.i.af7);
        }
        set startLabelBackground(v) {
            this.i.af7 = stringToBrush(v);
        }
        /**
         * Gets or sets the border color used for displaying Start annotation label.
        */
        get startLabelBorderColor() {
            return brushToString(this.i.af8);
        }
        set startLabelBorderColor(v) {
            this.i.af8 = stringToBrush(v);
        }
        /**
         * Gets or sets the text color used for displaying the end annotation label.
        */
        get endLabelTextColor() {
            return brushToString(this.i.af6);
        }
        set endLabelTextColor(v) {
            this.i.af6 = stringToBrush(v);
        }
        /**
         * Gets or sets the background used for displaying the end annotation label.
        */
        get endLabelBackground() {
            return brushToString(this.i.af4);
        }
        set endLabelBackground(v) {
            this.i.af4 = stringToBrush(v);
        }
        /**
         * Gets or sets the border used for displaying the end annotation label.
        */
        get endLabelBorderColor() {
            return brushToString(this.i.af5);
        }
        set endLabelBorderColor(v) {
            this.i.af5 = stringToBrush(v);
        }
        /**
         * Gets or sets the text color used for displaying the center annotation label.
        */
        get centerLabelTextColor() {
            return brushToString(this.i.af3);
        }
        set centerLabelTextColor(v) {
            this.i.af3 = stringToBrush(v);
        }
        /**
         * Gets or sets the background used for displaying the center annotation label.
        */
        get centerLabelBackground() {
            return brushToString(this.i.af1);
        }
        set centerLabelBackground(v) {
            this.i.af1 = stringToBrush(v);
        }
        /**
         * Gets or sets the border color used for displaying the center annotation label.
        */
        get centerLabelBorderColor() {
            return brushToString(this.i.af2);
        }
        set centerLabelBorderColor(v) {
            this.i.af2 = stringToBrush(v);
        }
    }
    IgxDataAnnotationRangeLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDataAnnotationRangeLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    IgxDataAnnotationRangeLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: IgxDataAnnotationRangeLayerComponent, selector: "ng-component", inputs: { startLabelTextColor: "startLabelTextColor", startLabelBackground: "startLabelBackground", startLabelBorderColor: "startLabelBorderColor", endLabelTextColor: "endLabelTextColor", endLabelBackground: "endLabelBackground", endLabelBorderColor: "endLabelBorderColor", centerLabelTextColor: "centerLabelTextColor", centerLabelBackground: "centerLabelBackground", centerLabelBorderColor: "centerLabelBorderColor" }, usesInheritance: true, ngImport: i0, template: ``, isInline: true });
    return IgxDataAnnotationRangeLayerComponent;
})();
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDataAnnotationRangeLayerComponent, decorators: [{
            type: Component,
            args: [{
                    template: ``,
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { startLabelTextColor: [{
                type: Input
            }], startLabelBackground: [{
                type: Input
            }], startLabelBorderColor: [{
                type: Input
            }], endLabelTextColor: [{
                type: Input
            }], endLabelBackground: [{
                type: Input
            }], endLabelBorderColor: [{
                type: Input
            }], centerLabelTextColor: [{
                type: Input
            }], centerLabelBackground: [{
                type: Input
            }], centerLabelBorderColor: [{
                type: Input
            }] } });
