import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxDataAnnotationPointLayerComponent } from "./igx-data-annotation-point-layer-component";
import { IgxDataAnnotationRangeLayerComponent } from "./igx-data-annotation-range-layer-component";
import { IgxDataAnnotationShapeLayerComponent } from "./igx-data-annotation-shape-layer-component";
import { IgxDataAnnotationAxisLayerComponent } from "./igx-data-annotation-axis-layer-component";
import { IgxAnnotationLayerComponent } from "./igx-annotation-layer-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { DataAnnotationRectLayer } from "./DataAnnotationRectLayer";
import * as i0 from "@angular/core";
/**
 * Represents an annotation layer that renders rectangles at locations of x/y values mapped to these properties:
 * StartValueXMemberPath
 * StartValueYMemberPath
 * EndValueXMemberPath
 * EndValueYMemberPath
*/
export let IgxDataAnnotationRectLayerComponent = /*@__PURE__*/ (() => {
    class IgxDataAnnotationRectLayerComponent extends IgxDataAnnotationPointLayerComponent {
        constructor() {
            super();
        }
        createImplementation() {
            return new DataAnnotationRectLayer();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
    }
    IgxDataAnnotationRectLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDataAnnotationRectLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    IgxDataAnnotationRectLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: IgxDataAnnotationRectLayerComponent, selector: "igx-data-annotation-rect-layer", providers: [{ provide: IgxDataAnnotationPointLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationRectLayerComponent) }, { provide: IgxDataAnnotationRangeLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationRectLayerComponent) }, { provide: IgxDataAnnotationShapeLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationRectLayerComponent) }, { provide: IgxDataAnnotationAxisLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationRectLayerComponent) }, { provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationRectLayerComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxDataAnnotationRectLayerComponent) }], usesInheritance: true, ngImport: i0, template: ``, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
    return IgxDataAnnotationRectLayerComponent;
})();
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDataAnnotationRectLayerComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'igx-data-annotation-rect-layer',
                    template: ``,
                    providers: [{ provide: IgxDataAnnotationPointLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationRectLayerComponent) }, { provide: IgxDataAnnotationRangeLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationRectLayerComponent) }, { provide: IgxDataAnnotationShapeLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationRectLayerComponent) }, { provide: IgxDataAnnotationAxisLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationRectLayerComponent) }, { provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationRectLayerComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxDataAnnotationRectLayerComponent) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }], ctorParameters: function () { return []; } });
