import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxDataAnnotationShapeLayerComponent } from "./igx-data-annotation-shape-layer-component";
import { IgxDataAnnotationAxisLayerComponent } from "./igx-data-annotation-axis-layer-component";
import { IgxAnnotationLayerComponent } from "./igx-annotation-layer-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { DataAnnotationSliceLayer } from "./DataAnnotationSliceLayer";
import * as i0 from "@angular/core";
/**
 * Represents an annotation layer that renders vertical or horizontal slices/lines at values mapped to AnnotationValueMemberPath property
 * horizontal slices/lines when TargetAxis is set to Y-axis
 * vertical slices/lines when TargetAxis is set to X-axis
*/
export let IgxDataAnnotationSliceLayerComponent = /*@__PURE__*/ (() => {
    class IgxDataAnnotationSliceLayerComponent extends IgxDataAnnotationShapeLayerComponent {
        constructor() {
            super();
        }
        createImplementation() {
            return new DataAnnotationSliceLayer();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        /**
         * Gets or sets name of data column with values used to position annotations.
        */
        get annotationValueMemberPath() {
            return this.i.afr;
        }
        set annotationValueMemberPath(v) {
            this.i.afr = v;
        }
        /**
         * Gets or sets mapping custom label on axis annotations.
        */
        get annotationLabelMemberPath() {
            return this.i.afo;
        }
        set annotationLabelMemberPath(v) {
            this.i.afo = v;
        }
    }
    IgxDataAnnotationSliceLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDataAnnotationSliceLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    IgxDataAnnotationSliceLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: IgxDataAnnotationSliceLayerComponent, selector: "igx-data-annotation-slice-layer", inputs: { annotationValueMemberPath: "annotationValueMemberPath", annotationLabelMemberPath: "annotationLabelMemberPath" }, providers: [{ provide: IgxDataAnnotationShapeLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationSliceLayerComponent) }, { provide: IgxDataAnnotationAxisLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationSliceLayerComponent) }, { provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationSliceLayerComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxDataAnnotationSliceLayerComponent) }], usesInheritance: true, ngImport: i0, template: ``, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
    return IgxDataAnnotationSliceLayerComponent;
})();
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDataAnnotationSliceLayerComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'igx-data-annotation-slice-layer',
                    template: ``,
                    providers: [{ provide: IgxDataAnnotationShapeLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationSliceLayerComponent) }, { provide: IgxDataAnnotationAxisLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationSliceLayerComponent) }, { provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxDataAnnotationSliceLayerComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxDataAnnotationSliceLayerComponent) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { annotationValueMemberPath: [{
                type: Input
            }], annotationLabelMemberPath: [{
                type: Input
            }] } });
