/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-angular-core";
import { HorizontalAlignment_$type } from "igniteui-angular-core";
import { VerticalAlignment_$type } from "igniteui-angular-core";
import { Visibility_$type } from "igniteui-angular-core";
import { ValueAxisLabelLocation_$type } from "./ValueAxisLabelLocation";
import { AngleAxisLabelLocation_$type } from "./AngleAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-angular-core";
/**
 * @hidden
 */
var RadialBaseChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBaseChart, _super);
    function RadialBaseChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.aas = null;
        _this.aat = null;
        _this.aa7 = 0;
        _this.aa9 = 5;
        _this.aa8 = 0;
        _this.aa6 = 5;
        _this.abq = 5;
        _this.abs = 0;
        _this.abr = 5;
        _this.abp = 0;
        _this.agt = null;
        _this.ag0 = null;
        _this.agr = null;
        _this.ags = null;
        _this.abk = 0;
        _this.ab3 = 0;
        _this.abj = NaN;
        _this.ab2 = NaN;
        _this.abm = NaN;
        _this.ab5 = NaN;
        _this.abl = NaN;
        _this.ab4 = NaN;
        _this.abi = NaN;
        _this.ab1 = NaN;
        _this.agz = null;
        _this.ag6 = null;
        _this.adh = null;
        _this.adl = null;
        _this.adj = null;
        _this.adn = null;
        _this.adc = null;
        _this.add = null;
        _this.agu = null;
        _this.ag1 = null;
        _this.aba = DeviceUtils.g(1);
        _this.abt = DeviceUtils.g(1);
        _this.abd = DeviceUtils.g(1);
        _this.abw = DeviceUtils.g(1);
        _this.agw = null;
        _this.ag3 = null;
        _this.agx = null;
        _this.ag4 = null;
        _this.abe = DeviceUtils.g(1);
        _this.abx = DeviceUtils.g(1);
        _this.abf = DeviceUtils.g(8);
        _this.aby = 0;
        _this.agy = null;
        _this.ag5 = null;
        _this.abg = DeviceUtils.g(1);
        _this.abz = DeviceUtils.g(1);
        _this.adi = null;
        _this.adm = null;
        _this.agv = null;
        _this.ag2 = null;
        _this.aa5 = 0;
        _this.abo = 0;
        _this.aa4 = NaN;
        _this.abb = NaN;
        _this.abc = NaN;
        _this.abn = NaN;
        _this.abu = NaN;
        _this.abv = NaN;
        _this.abh = 0;
        _this.ab0 = -90;
        _this.aa0 = false;
        _this.aa1 = false;
        _this.agm = 1;
        _this.ahp = 1;
        _this.agl = 1;
        _this.agn = 2;
        _this.ahn = 0;
        _this.aho = 1;
        _this.aht = 0;
        _this.ahu = 0;
        _this.aay = 4;
        _this.aao = 4;
        _this.adg = null;
        _this.aak = null;
        _this.adk = null;
        _this.aal = null;
        return _this;
    }
    RadialBaseChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.aaq();
            var c = this.aar();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    RadialBaseChart.prototype.vm = function () {
        _super.prototype.vm.call(this);
        var a = this.aaq();
        var b = this.aar();
        if (a != null && a.az != null) {
            this.ag9 = a.az.textColor;
        }
        if (b != null && b.az != null) {
            this.ahg = b.az.textColor;
        }
        this.ahe = AxisDefaults.axis_TickBrush;
        this.ahl = AxisDefaults.axis_TickBrush;
        this.aha = AxisDefaults.axis_MajorBrush;
        this.ahh = AxisDefaults.axis_MajorBrush;
        this.ahd = AxisDefaults.axis_LineBrush;
        this.ahk = AxisDefaults.axis_LineBrush;
    };
    RadialBaseChart.prototype.wh = function (a, b, c) {
        var _this = this;
        _super.prototype.wh.call(this, a, b, c);
        switch (a) {
            case "AngleAxisLabelLeftMargin":
                this.agd(function (d) { return d.leftMargin = _this.ab9; });
                break;
            case "AngleAxisLabelTopMargin":
                this.agd(function (d) { return d.topMargin = _this.acb; });
                break;
            case "AngleAxisLabelRightMargin":
                this.agd(function (d) { return d.rightMargin = _this.aca; });
                break;
            case "AngleAxisLabelBottomMargin":
                this.agd(function (d) { return d.bottomMargin = _this.ab8; });
                break;
            case "ValueAxisLabelLeftMargin":
                this.agi(function (d) { return d.leftMargin = _this.acw; });
                break;
            case "ValueAxisLabelTopMargin":
                this.agi(function (d) { return d.topMargin = _this.acy; });
                break;
            case "ValueAxisLabelRightMargin":
                this.agi(function (d) { return d.rightMargin = _this.acx; });
                break;
            case "ValueAxisLabelBottomMargin":
                this.agi(function (d) { return d.bottomMargin = _this.acv; });
                break;
            case "ActualItemsSource":
            case "ShouldDisplayMockData":
            case "ShouldUseSkeletonStyleForMockData":
                this.ag7 = this.zi(this.ag9);
                this.ag8 = this.zi(this.ahg);
                break;
            case "AngleAxisLabelTextColor":
                this.ag7 = this.zi(this.ag9);
                break;
            case "ValueAxisLabelTextColor":
                this.ag8 = this.zi(this.ahg);
                break;
            case "ActualAngleAxisLabelTextColor":
                this.agd(function (d) { return d.textColor = _this.ag7; });
                break;
            case "ActualValueAxisLabelTextColor":
                this.agi(function (d) { return d.textColor = _this.ag8; });
                break;
            case "AngleAxisTitleMargin":
                this.agf(function (d) { return d.margin = _this.acm; });
                break;
            case "ValueAxisTitleMargin":
                this.agk(function (d) { return d.margin = _this.ac9; });
                break;
            case "AngleAxisTitleLeftMargin":
                this.agf(function (d) { return d.leftMargin = _this.acl; });
                break;
            case "ValueAxisTitleLeftMargin":
                this.agk(function (d) { return d.leftMargin = _this.ac8; });
                break;
            case "AngleAxisTitleTopMargin":
                this.agf(function (d) { return d.topMargin = _this.aco; });
                break;
            case "ValueAxisTitleTopMargin":
                this.agk(function (d) { return d.topMargin = _this.adb; });
                break;
            case "AngleAxisTitleRightMargin":
                this.agf(function (d) { return d.rightMargin = _this.acn; });
                break;
            case "ValueAxisTitleRightMargin":
                this.agk(function (d) { return d.rightMargin = _this.ada; });
                break;
            case "AngleAxisTitleBottomMargin":
                this.agf(function (d) { return d.bottomMargin = _this.ack; });
                break;
            case "ValueAxisTitleBottomMargin":
                this.agk(function (d) { return d.bottomMargin = _this.ac7; });
                break;
            case "AngleAxisTitleTextColor":
                this.agf(function (d) { return d.textColor = _this.ahf; });
                break;
            case "ValueAxisTitleTextColor":
                this.agk(function (d) { return d.textColor = _this.ahm; });
                break;
            case "AngleAxisFormatLabel":
                this.agb(function (d) { return d.au = _this.aau; });
                break;
            case "ValueAxisFormatLabel":
                this.agg(function (d) { return d.au = _this.aav; });
                break;
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "aau", {
        get: function () {
            return this.aas;
        },
        set: function (a) {
            var b = this.aau;
            if (a != b) {
                this.aas = a;
                this.wd("AngleAxisFormatLabel", b, this.aau);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aav", {
        get: function () {
            return this.aat;
        },
        set: function (a) {
            var b = this.aav;
            if (a != b) {
                this.aat = a;
                this.wd("ValueAxisFormatLabel", b, this.aav);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ab9", {
        get: function () {
            return this.aa7;
        },
        set: function (a) {
            var b = this.ab9;
            if (a != b) {
                this.aa7 = a;
                this.wd("AngleAxisLabelLeftMargin", b, this.ab9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acb", {
        get: function () {
            return this.aa9;
        },
        set: function (a) {
            var b = this.acb;
            if (a != b) {
                this.aa9 = a;
                this.wd("AngleAxisLabelTopMargin", b, this.acb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aca", {
        get: function () {
            return this.aa8;
        },
        set: function (a) {
            var b = this.aca;
            if (a != b) {
                this.aa8 = a;
                this.wd("AngleAxisLabelRightMargin", b, this.aca);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ab8", {
        get: function () {
            return this.aa6;
        },
        set: function (a) {
            var b = this.ab8;
            if (a != b) {
                this.aa6 = a;
                this.wd("AngleAxisLabelBottomMargin", b, this.ab8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acw", {
        get: function () {
            return this.abq;
        },
        set: function (a) {
            var b = this.acw;
            if (a != b) {
                this.abq = a;
                this.wd("ValueAxisLabelLeftMargin", b, this.acw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acy", {
        get: function () {
            return this.abs;
        },
        set: function (a) {
            var b = this.acy;
            if (a != b) {
                this.abs = a;
                this.wd("ValueAxisLabelTopMargin", b, this.acy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acx", {
        get: function () {
            return this.abr;
        },
        set: function (a) {
            var b = this.acx;
            if (a != b) {
                this.abr = a;
                this.wd("ValueAxisLabelRightMargin", b, this.acx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acv", {
        get: function () {
            return this.abp;
        },
        set: function (a) {
            var b = this.acv;
            if (a != b) {
                this.abp = a;
                this.wd("ValueAxisLabelBottomMargin", b, this.acv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ag9", {
        get: function () {
            return this.agt;
        },
        set: function (a) {
            var b = this.ag9;
            if (a != b) {
                this.agt = a;
                this.wd("AngleAxisLabelTextColor", b, this.ag9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahg", {
        get: function () {
            return this.ag0;
        },
        set: function (a) {
            var b = this.ahg;
            if (a != b) {
                this.ag0 = a;
                this.wd("ValueAxisLabelTextColor", b, this.ahg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ag7", {
        get: function () {
            return this.agr;
        },
        set: function (a) {
            var b = this.agr;
            if (a != b) {
                this.agr = a;
                this.wd("ActualAngleAxisLabelTextColor", b, this.ag7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ag8", {
        get: function () {
            return this.ags;
        },
        set: function (a) {
            var b = this.ags;
            if (a != b) {
                this.ags = a;
                this.wd("ActualValueAxisLabelTextColor", b, this.ag8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acm", {
        get: function () {
            return this.abk;
        },
        set: function (a) {
            var b = this.acm;
            if (a != b) {
                this.abk = a;
                this.wd("AngleAxisTitleMargin", b, this.acm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac9", {
        get: function () {
            return this.ab3;
        },
        set: function (a) {
            var b = this.ac9;
            if (a != b) {
                this.ab3 = a;
                this.wd("ValueAxisTitleMargin", b, this.ac9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acl", {
        get: function () {
            return this.abj;
        },
        set: function (a) {
            var b = this.acl;
            if (a != b) {
                this.abj = a;
                this.wd("AngleAxisTitleLeftMargin", b, this.acl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac8", {
        get: function () {
            return this.ab2;
        },
        set: function (a) {
            var b = this.ac8;
            if (a != b) {
                this.ab2 = a;
                this.wd("ValueAxisTitleLeftMargin", b, this.ac8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aco", {
        get: function () {
            return this.abm;
        },
        set: function (a) {
            var b = this.aco;
            if (a != b) {
                this.abm = a;
                this.wd("AngleAxisTitleTopMargin", b, this.aco);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "adb", {
        get: function () {
            return this.ab5;
        },
        set: function (a) {
            var b = this.adb;
            if (a != b) {
                this.ab5 = a;
                this.wd("ValueAxisTitleTopMargin", b, this.adb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acn", {
        get: function () {
            return this.abl;
        },
        set: function (a) {
            var b = this.acn;
            if (a != b) {
                this.abl = a;
                this.wd("AngleAxisTitleRightMargin", b, this.acn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ada", {
        get: function () {
            return this.ab4;
        },
        set: function (a) {
            var b = this.ada;
            if (a != b) {
                this.ab4 = a;
                this.wd("ValueAxisTitleRightMargin", b, this.ada);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ack", {
        get: function () {
            return this.abi;
        },
        set: function (a) {
            var b = this.ack;
            if (a != b) {
                this.abi = a;
                this.wd("AngleAxisTitleBottomMargin", b, this.ack);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac7", {
        get: function () {
            return this.ab1;
        },
        set: function (a) {
            var b = this.ac7;
            if (a != b) {
                this.ab1 = a;
                this.wd("ValueAxisTitleBottomMargin", b, this.ac7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahf", {
        get: function () {
            return this.agz;
        },
        set: function (a) {
            var b = this.ahf;
            if (a != b) {
                this.agz = a;
                this.wd("AngleAxisTitleTextColor", b, this.ahf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahm", {
        get: function () {
            return this.ag6;
        },
        set: function (a) {
            var b = this.ahm;
            if (a != b) {
                this.ag6 = a;
                this.wd("ValueAxisTitleTextColor", b, this.ahm);
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.wi = function (a, b, c) {
        var _this = this;
        _super.prototype.wi.call(this, a, b, c);
        switch (a) {
            case "AngleAxisLabelTextStyle":
                this.agd(function (d) { return d.textStyle = _this.ad4; });
                break;
            case "ValueAxisLabelTextStyle":
                this.agi(function (d) { return d.textStyle = _this.afc; });
                break;
            case "AngleAxisTitleTextStyle":
                this.agf(function (d) { return d.textStyle = _this.aeu; });
                break;
            case "ValueAxisTitleTextStyle":
                this.agk(function (d) { return d.textStyle = _this.af2; });
                break;
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "ad4", {
        get: function () {
            return this.adh;
        },
        set: function (a) {
            var b = this.ad4;
            if (a != b) {
                this.adh = a;
                this.wd("AngleAxisLabelTextStyle", b, this.ad4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afc", {
        get: function () {
            return this.adl;
        },
        set: function (a) {
            var b = this.afc;
            if (a != b) {
                this.adl = a;
                this.wd("ValueAxisLabelTextStyle", b, this.afc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aeu", {
        get: function () {
            return this.adj;
        },
        set: function (a) {
            var b = this.aeu;
            if (a != b) {
                this.adj = a;
                this.wd("AngleAxisTitleTextStyle", b, this.aeu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "af2", {
        get: function () {
            return this.adn;
        },
        set: function (a) {
            var b = this.af2;
            if (a != b) {
                this.adn = a;
                this.wd("ValueAxisTitleTextStyle", b, this.af2);
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.af8 = function (a) {
        var _this = this;
        this.af5(a, function (b) { return b.leftMargin = _this.ab9; });
        this.af5(a, function (b) { return b.topMargin = _this.acb; });
        this.af5(a, function (b) { return b.rightMargin = _this.aca; });
        this.af5(a, function (b) { return b.bottomMargin = _this.ab8; });
        this.af5(a, function (b) { return b.textColor = _this.ag7; });
        this.af6(a, function (b) { return b.textColor = _this.ahf; });
        this.af6(a, function (b) { return b.leftMargin = _this.acl; });
        this.af6(a, function (b) { return b.topMargin = _this.aco; });
        this.af6(a, function (b) { return b.rightMargin = _this.acn; });
        this.af6(a, function (b) { return b.bottomMargin = _this.ack; });
        this.af5(a, function (b) { return b.textStyle = _this.ad4; });
        this.af6(a, function (b) { return b.textStyle = _this.aeu; });
    };
    RadialBaseChart.prototype.aga = function (a) {
        var _this = this;
        this.af5(a, function (b) { return b.leftMargin = _this.acw; });
        this.af5(a, function (b) { return b.topMargin = _this.acy; });
        this.af5(a, function (b) { return b.rightMargin = _this.acx; });
        this.af5(a, function (b) { return b.bottomMargin = _this.acv; });
        this.af5(a, function (b) { return b.textColor = _this.ag8; });
        this.af6(a, function (b) { return b.textColor = _this.ahm; });
        this.af6(a, function (b) { return b.leftMargin = _this.ac8; });
        this.af6(a, function (b) { return b.topMargin = _this.adb; });
        this.af6(a, function (b) { return b.rightMargin = _this.ada; });
        this.af6(a, function (b) { return b.bottomMargin = _this.ac7; });
        this.af5(a, function (b) { return b.textStyle = _this.afc; });
        this.af6(a, function (b) { return b.textStyle = _this.af2; });
    };
    RadialBaseChart.prototype.w9 = function (a) {
        var b = this.be(a);
        var c = this.dc(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = this.h6(a);
        if (a.highlightedData != null) {
            c.highlightedItemsSource = this.h7(a);
        }
        c.name = this.q0(a);
        c.title = this.q1(a, b);
        this.dataChart.series.add(c);
    };
    RadialBaseChart.prototype.agb = function (a) {
        this.agc(a, null);
    };
    RadialBaseChart.prototype.agc = function (a, b) {
        a(this.aaq());
    };
    RadialBaseChart.prototype.agh = function (a, b) {
        a(this.aar());
    };
    RadialBaseChart.prototype.agg = function (a) {
        this.agh(a, true);
    };
    RadialBaseChart.prototype.u5 = function (a, b) {
        this.agb(a);
        this.agh(a, b);
    };
    RadialBaseChart.prototype.agf = function (a) {
        this.af6(this.aaq(), a);
    };
    RadialBaseChart.prototype.agk = function (a) {
        this.af6(this.aar(), a);
    };
    RadialBaseChart.prototype.agi = function (a) {
        this.af5(this.aar(), a);
    };
    RadialBaseChart.prototype.agd = function (a) {
        this.af5(this.aaq(), a);
    };
    RadialBaseChart.prototype.acp = function (a) {
        var b = this.aaq();
        return b.el(a, new ScalerParams(1, this.zr, this.zq, b.ch));
    };
    RadialBaseChart.prototype.acr = function (a) {
        var b = this.aaq();
        return b.eo(a, new ScalerParams(1, this.zr, this.zq, b.ch));
    };
    RadialBaseChart.prototype.acq = function (a) {
        var b = this.aar();
        return b.el(a, new ScalerParams(1, this.zr, this.zq, b.ch));
    };
    RadialBaseChart.prototype.acs = function (a) {
        var b = this.aar();
        return b.eo(a, new ScalerParams(1, this.zr, this.zq, b.ch));
    };
    RadialBaseChart.prototype.w6 = function (a) {
        _super.prototype.w6.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.aaq();
            var c = this.aar();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    RadialBaseChart.aex = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    RadialBaseChart.prototype.vh = function (a, b) {
        _super.prototype.vh.call(this, a, b);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.aaq());
            this.dataChart.axes.add(this.aar());
        }
    };
    RadialBaseChart.prototype.af7 = function (a) {
        var _this = this;
        if (a != null && this.l4 != null && a.fn == null) {
            a.provideRenderer(this.l4);
        }
        a.jz = this.aha;
        a.et = this.acc;
        a.j0 = this.ahb;
        a.ew = this.acf;
        a.j2 = this.ahd;
        a.fi = this.acg;
        a.j1 = this.ahc;
        a.fj = this.ach;
        a.j3 = this.ahe;
        a.fk = this.aci;
        a.c4 = true;
        a.cu = this.shouldAvoidAxisAnnotationCollisions;
        a.cw = this.shouldAvoidAxisAnnotationCollisions;
        var b = a == this.aaq();
        if (b) {
            a.g8 = this.ael;
        }
        a.f2 = this.ade;
        a.gi = this.adv;
        a.ah = this.aam;
        this.af5(a, function (c) { return c.angle = _this.ab7; });
        this.af5(a, function (c) {
            if (c.extent != _this.ab6) {
                c.extent = _this.ab6;
            }
        });
        this.af5(a, function (c) {
            if (c.maximumExtent != _this.acd) {
                c.maximumExtent = _this.acd;
            }
        });
        this.af5(a, function (c) {
            if (c.maximumExtentPercentage != _this.ace) {
                c.maximumExtentPercentage = _this.ace;
            }
        });
        this.af5(a, function (c) { return c.horizontalAlignment = _this.ago; });
        this.af5(a, function (c) { return c.verticalAlignment = _this.ahq; });
        this.af5(a, function (c) { return c.visibility = _this.ahv; });
        this.af5(a, function (c) { return c.location = _this.aaw(_this.aap); });
        this.af6(a, function (c) { return c.horizontalAlignment = _this.agp; });
        this.af6(a, function (c) { return c.angle = _this.acj; });
        this.af8(a);
    };
    RadialBaseChart.prototype.af9 = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.l4 != null && a.fn == null) {
            a.provideRenderer(this.l4);
        }
        a.cu = this.shouldAvoidAxisAnnotationCollisions;
        a.cw = this.shouldAvoidAxisAnnotationCollisions;
        this.af5(a, function (b) { return b.angle = _this.acu; });
        this.af5(a, function (b) {
            if (b.extent != _this.act) {
                b.extent = _this.act;
            }
        });
        this.af5(a, function (b) {
            if (b.maximumExtent != _this.ac0) {
                b.maximumExtent = _this.ac0;
            }
        });
        this.af5(a, function (b) {
            if (b.maximumExtentPercentage != _this.ac1) {
                b.maximumExtentPercentage = _this.ac1;
            }
        });
        this.af5(a, function (b) { return b.horizontalAlignment = _this.agq; });
        this.af5(a, function (b) { return b.verticalAlignment = _this.ahr; });
        this.af5(a, function (b) { return b.visibility = _this.ahw; });
        this.af5(a, function (b) { return b.location = _this.aax(_this.aaz); });
        this.af6(a, function (b) { return b.verticalAlignment = _this.ahs; });
        this.af6(a, function (b) { return b.angle = _this.ac6; });
        a.jz = this.ahh;
        a.et = this.acz;
        a.j0 = this.ahi;
        a.ew = this.ac2;
        a.j2 = this.ahk;
        a.fi = this.ac3;
        a.j1 = this.ahj;
        a.fj = this.ac4;
        a.j3 = this.ahl;
        a.fk = this.ac5;
        var b = a == this.aar();
        if (b) {
            a.g8 = this.aft;
        }
        a.gi = this.ae3;
        a.ah = this.aan;
        this.aga(a);
    };
    RadialBaseChart.prototype.ve = function () {
        _super.prototype.ve.call(this);
        this.af7(this.aaq());
        this.af9(this.aar());
    };
    RadialBaseChart.prototype.af5 = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.az == null) {
            a.az = new AxisLabelSettings();
            a.az.angle = a.d7();
            a.az.bottomMargin = a.d8();
            a.az.leftMargin = a.d9();
            a.az.rightMargin = a.ea();
            a.az.topMargin = a.eb();
            a.az.horizontalAlignment = a.ju();
            a.az.location = a.a0();
            a.az.verticalAlignment = a.ko();
        }
        b(a.az);
    };
    RadialBaseChart.prototype.af6 = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.bf == null) {
            a.bf = new TitleSettings();
            a.bf.bottomMargin = a.ed();
            a.bf.leftMargin = a.ee();
            a.bf.rightMargin = a.ef();
            a.bf.topMargin = a.eg();
            a.bf.location = a.a1();
            a.bf.angle = a.ec();
            a.bf.horizontalAlignment = a.jv();
            a.bf.verticalAlignment = a.kp();
        }
        b(a.bf);
    };
    RadialBaseChart.prototype.wd = function (a, b, c) {
        var _this = this;
        _super.prototype.wd.call(this, a, b, c);
        switch (a) {
            case "AngleAxisLabelAngle":
                this.agd(function (d) { return d.angle = _this.ab7; });
                break;
            case "ValueAxisLabelAngle":
                this.agi(function (d) { return d.angle = _this.acu; });
                break;
            case "AngleAxisLabelHorizontalAlignment":
                this.agd(function (d) { return d.horizontalAlignment = _this.ago; });
                break;
            case "ValueAxisLabelHorizontalAlignment":
                this.agi(function (d) { return d.horizontalAlignment = _this.agq; });
                break;
            case "AngleAxisLabelVerticalAlignment":
                this.agd(function (d) { return d.verticalAlignment = _this.ahq; });
                break;
            case "ValueAxisLabelVerticalAlignment":
                this.agi(function (d) { return d.verticalAlignment = _this.ahr; });
                break;
            case "AngleAxisLabelVisibility":
                this.agd(function (d) { return d.visibility = _this.ahv; });
                break;
            case "ValueAxisLabelVisibility":
                this.agi(function (d) { return d.visibility = _this.ahw; });
                break;
            case "AngleAxisLabel":
                this.agb(function (d) { return d.f2 = _this.ade; });
                break;
            case "ValueAxisLabel":
                this.agg(function (d) { return d.f2 = _this.adf; });
                break;
            case "AngleAxisLabelFormat":
                this.agb(function (d) { return d.gi = _this.adv; });
                break;
            case "AngleAxisLabelFormatSpecifiers":
                this.agb(function (d) { return d.ah = _this.aam; });
                break;
            case "ValueAxisLabelFormat":
                this.agg(function (d) { return d.gi = _this.ae3; });
                break;
            case "ValueAxisLabelFormatSpecifiers":
                this.agg(function (d) { return d.ah = _this.aan; });
                break;
            case "AngleAxisTitleAngle":
                this.agf(function (d) { return d.angle = _this.acj; });
                break;
            case "ValueAxisTitleAngle":
                this.agk(function (d) { return d.angle = _this.ac6; });
                break;
            case "AngleAxisTitleAlignment":
                this.agf(function (d) { return d.horizontalAlignment = _this.agp; });
                break;
            case "ValueAxisTitleAlignment":
                this.agk(function (d) { return d.verticalAlignment = _this.ahs; });
                break;
            case "AngleAxisTitle":
                this.agb(function (d) { return d.g8 = _this.ael; });
                break;
            case "ValueAxisTitle":
                this.agh(function (d) { return d.g8 = _this.aft; }, false);
                break;
            case "AngleAxisMajorStroke":
                this.agc(function (d) { return d.jz = _this.aha; }, a);
                break;
            case "ValueAxisMajorStroke":
                this.agg(function (d) { return d.jz = _this.ahh; });
                break;
            case "AngleAxisMajorStrokeThickness":
                this.agc(function (d) { return d.et = _this.acc; }, a);
                break;
            case "ValueAxisMajorStrokeThickness":
                this.agg(function (d) { return d.et = _this.acz; });
                break;
            case "AngleAxisMinorStroke":
                this.agb(function (d) { return d.j0 = _this.ahb; });
                break;
            case "ValueAxisMinorStroke":
                this.agg(function (d) { return d.j0 = _this.ahi; });
                break;
            case "AngleAxisMinorStrokeThickness":
                this.agb(function (d) { return d.ew = _this.acf; });
                break;
            case "ValueAxisMinorStrokeThickness":
                this.agg(function (d) { return d.ew = _this.ac2; });
                break;
            case "AngleAxisTickLength":
                this.agb(function (d) { return d.fj = _this.ach; });
                break;
            case "ValueAxisTickLength":
                this.agg(function (d) { return d.fj = _this.ac4; });
                break;
            case "AngleAxisTickStroke":
                this.agb(function (d) { return d.j3 = _this.ahe; });
                break;
            case "ValueAxisTickStroke":
                this.agg(function (d) { return d.j3 = _this.ahl; });
                break;
            case "AngleAxisTickStrokeThickness":
                this.agb(function (d) { return d.fk = _this.aci; });
                break;
            case "ValueAxisTickStrokeThickness":
                this.agg(function (d) { return d.fk = _this.ac5; });
                break;
            case "AngleAxisStroke":
                this.agb(function (d) { return d.j2 = _this.ahd; });
                break;
            case "ValueAxisStroke":
                this.agg(function (d) { return d.j2 = _this.ahk; });
                break;
            case "AngleAxisStrokeThickness":
                this.agb(function (d) { return d.fi = _this.acg; });
                break;
            case "ValueAxisStrokeThickness":
                this.agg(function (d) { return d.fi = _this.ac3; });
                break;
            case "AngleAxisExtent":
                this.agd(function (d) { return d.extent = _this.ab6; });
                break;
            case "AngleAxisMaximumExtent":
                this.agd(function (d) { return d.maximumExtent = _this.acd; });
                break;
            case "AngleAxisMaximumExtentPercentage":
                this.agd(function (d) { return d.maximumExtentPercentage = _this.ace; });
                break;
            case "ValueAxisExtent":
                this.agi(function (d) { return d.extent = _this.act; });
                break;
            case "ValueAxisMaximumExtent":
                this.agi(function (d) { return d.maximumExtent = _this.acd; });
                break;
            case "ValueAxisMaximumExtentPercentage":
                this.agi(function (d) { return d.maximumExtentPercentage = _this.ace; });
                break;
            case "AngleAxisStrip":
                this.agb(function (d) { return d.j1 = _this.ahc; });
                break;
            case "ValueAxisStrip":
                this.agg(function (d) { return d.j1 = _this.ahj; });
                break;
            case "AngleAxisInverted":
                this.agb(function (d) { return d.ch = _this.aa2; });
                break;
            case "ValueAxisInverted":
                this.agg(function (d) { return d.ch = _this.aa3; });
                break;
            case "ValueAxisLabelLocation":
                this.agj();
                break;
            case "AngleAxisLabelLocation":
                this.age();
                break;
        }
    };
    RadialBaseChart.prototype.agj = function () {
        var a = this.aax(this.aaz);
        if (a == 2 || a == 7) {
            this.agq = 2;
        }
        else {
            this.agq = 0;
        }
        this.agi(function (b) { return b.location = a; });
    };
    RadialBaseChart.prototype.age = function () {
        var a = this.aaw(this.aap);
        if (a == 1 || a == 5) {
            this.ahq = 0;
        }
        else {
            this.ahq = 2;
        }
        this.agd(function (b) { return b.location = a; });
    };
    RadialBaseChart.prototype.aax = function (a) {
        if (a == 0) {
            return 2;
        }
        else if (a == 1) {
            return 3;
        }
        else if (a == 3) {
            return 7;
        }
        else if (a == 2) {
            return 6;
        }
        else {
            if (this.cb == 1) {
                return 3;
            }
            else {
                return 2;
            }
        }
    };
    RadialBaseChart.prototype.aaw = function (a) {
        if (a == 1) {
            return 1;
        }
        else if (a == 0) {
            return 0;
        }
        else if (a == 3) {
            return 5;
        }
        else if (a == 2) {
            return 4;
        }
        else {
            return 1;
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "ade", {
        get: function () {
            return this.adc;
        },
        set: function (a) {
            var b = this.ade;
            if (a != b) {
                this.adc = a;
                this.wd("AngleAxisLabel", b, this.ade);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "adf", {
        get: function () {
            return this.add;
        },
        set: function (a) {
            var b = this.adf;
            if (a != b) {
                this.add = a;
                this.wd("ValueAxisLabel", b, this.adf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aha", {
        get: function () {
            return this.agu;
        },
        set: function (a) {
            var b = this.aha;
            if (a != b) {
                this.agu = a;
                this.wd("AngleAxisMajorStroke", b, this.aha);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahh", {
        get: function () {
            return this.ag1;
        },
        set: function (a) {
            var b = this.ahh;
            if (a != b) {
                this.ag1 = a;
                this.wd("ValueAxisMajorStroke", b, this.ahh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acc", {
        get: function () {
            return this.aba;
        },
        set: function (a) {
            var b = this.acc;
            if (a != b) {
                this.aba = a;
                this.wd("AngleAxisMajorStrokeThickness", b, this.acc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acz", {
        get: function () {
            return this.abt;
        },
        set: function (a) {
            var b = this.acz;
            if (a != b) {
                this.abt = a;
                this.wd("ValueAxisMajorStrokeThickness", b, this.acz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acf", {
        get: function () {
            return this.abd;
        },
        set: function (a) {
            var b = this.acf;
            if (a != b) {
                this.abd = a;
                this.wd("AngleAxisMinorStrokeThickness", b, this.acf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac2", {
        get: function () {
            return this.abw;
        },
        set: function (a) {
            var b = this.ac2;
            if (a != b) {
                this.abw = a;
                this.wd("ValueAxisMinorStrokeThickness", b, this.ac2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahc", {
        get: function () {
            return this.agw;
        },
        set: function (a) {
            var b = this.ahc;
            if (a != b) {
                this.agw = a;
                this.wd("AngleAxisStrip", b, this.ahc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahj", {
        get: function () {
            return this.ag3;
        },
        set: function (a) {
            var b = this.ahj;
            if (a != b) {
                this.ag3 = a;
                this.wd("ValueAxisStrip", b, this.ahj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahd", {
        get: function () {
            return this.agx;
        },
        set: function (a) {
            var b = this.ahd;
            if (a != b) {
                this.agx = a;
                this.wd("AngleAxisStroke", b, this.ahd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahk", {
        get: function () {
            return this.ag4;
        },
        set: function (a) {
            var b = this.ahk;
            if (a != b) {
                this.ag4 = a;
                this.wd("ValueAxisStroke", b, this.ahk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acg", {
        get: function () {
            return this.abe;
        },
        set: function (a) {
            var b = this.acg;
            if (a != b) {
                this.abe = a;
                this.wd("AngleAxisStrokeThickness", b, this.acg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac3", {
        get: function () {
            return this.abx;
        },
        set: function (a) {
            var b = this.ac3;
            if (a != b) {
                this.abx = a;
                this.wd("ValueAxisStrokeThickness", b, this.ac3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ach", {
        get: function () {
            return this.abf;
        },
        set: function (a) {
            var b = this.ach;
            if (a != b) {
                this.abf = a;
                this.wd("AngleAxisTickLength", b, this.ach);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac4", {
        get: function () {
            return this.aby;
        },
        set: function (a) {
            var b = this.ac4;
            if (a != b) {
                this.aby = a;
                this.wd("ValueAxisTickLength", b, this.ac4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahe", {
        get: function () {
            return this.agy;
        },
        set: function (a) {
            var b = this.ahe;
            if (a != b) {
                this.agy = a;
                this.wd("AngleAxisTickStroke", b, this.ahe);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahl", {
        get: function () {
            return this.ag5;
        },
        set: function (a) {
            var b = this.ahl;
            if (a != b) {
                this.ag5 = a;
                this.wd("ValueAxisTickStroke", b, this.ahl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aci", {
        get: function () {
            return this.abg;
        },
        set: function (a) {
            var b = this.aci;
            if (a != b) {
                this.abg = a;
                this.wd("AngleAxisTickStrokeThickness", b, this.aci);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac5", {
        get: function () {
            return this.abz;
        },
        set: function (a) {
            var b = this.ac5;
            if (a != b) {
                this.abz = a;
                this.wd("ValueAxisTickStrokeThickness", b, this.ac5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ael", {
        get: function () {
            return this.adi;
        },
        set: function (a) {
            var b = this.ael;
            if (a != b) {
                this.adi = a;
                this.wd("AngleAxisTitle", b, this.ael);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aft", {
        get: function () {
            return this.adm;
        },
        set: function (a) {
            var b = this.aft;
            if (a != b) {
                this.adm = a;
                this.wd("ValueAxisTitle", b, this.aft);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahb", {
        get: function () {
            return this.agv;
        },
        set: function (a) {
            var b = this.ahb;
            if (a != b) {
                this.agv = a;
                this.wd("AngleAxisMinorStroke", b, this.ahb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahi", {
        get: function () {
            return this.ag2;
        },
        set: function (a) {
            var b = this.ahi;
            if (a != b) {
                this.ag2 = a;
                this.wd("ValueAxisMinorStroke", b, this.ahi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ab7", {
        get: function () {
            return this.aa5;
        },
        set: function (a) {
            var b = this.ab7;
            if (a != b) {
                this.aa5 = a;
                this.wd("AngleAxisLabelAngle", b, this.ab7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acu", {
        get: function () {
            return this.abo;
        },
        set: function (a) {
            var b = this.acu;
            if (a != b) {
                this.abo = a;
                this.wd("ValueAxisLabelAngle", b, this.acu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ab6", {
        get: function () {
            return this.aa4;
        },
        set: function (a) {
            var b = this.ab6;
            if (a != b) {
                this.aa4 = a;
                this.wd("AngleAxisExtent", b, this.ab6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acd", {
        get: function () {
            return this.abb;
        },
        set: function (a) {
            var b = this.acd;
            if (a != b) {
                this.abb = a;
                this.wd("AngleAxisMaximumExtent", b, this.acd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ace", {
        get: function () {
            return this.abc;
        },
        set: function (a) {
            var b = this.ace;
            if (a != b) {
                this.abc = a;
                this.wd("AngleAxisMaximumExtentPercentage", b, this.ace);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "act", {
        get: function () {
            return this.abn;
        },
        set: function (a) {
            var b = this.act;
            if (a != b) {
                this.abn = a;
                this.wd("ValueAxisExtent", b, this.act);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac0", {
        get: function () {
            return this.abu;
        },
        set: function (a) {
            var b = this.ac0;
            if (a != b) {
                this.abu = a;
                this.wd("ValueAxisMaximumExtent", b, this.ac0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac1", {
        get: function () {
            return this.abv;
        },
        set: function (a) {
            var b = this.ac1;
            if (a != b) {
                this.abv = a;
                this.wd("ValueAxisMaximumExtentPercentage", b, this.ac1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acj", {
        get: function () {
            return this.abh;
        },
        set: function (a) {
            var b = this.acj;
            if (a != b) {
                this.abh = a;
                this.wd("AngleAxisTitleAngle", b, this.acj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac6", {
        get: function () {
            return this.ab0;
        },
        set: function (a) {
            var b = this.ac6;
            if (a != b) {
                this.ab0 = a;
                this.wd("ValueAxisTitleAngle", b, this.ac6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aa2", {
        get: function () {
            return this.aa0;
        },
        set: function (a) {
            var b = this.aa2;
            if (a != b) {
                this.aa0 = a;
                this.wd("AngleAxisInverted", b, this.aa2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aa3", {
        get: function () {
            return this.aa1;
        },
        set: function (a) {
            var b = this.aa3;
            if (a != b) {
                this.aa1 = a;
                this.wd("ValueAxisInverted", b, this.aa3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "agp", {
        get: function () {
            return this.agm;
        },
        set: function (a) {
            var b = this.agp;
            if (a != b) {
                this.agm = a;
                this.wd("AngleAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agp));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahs", {
        get: function () {
            return this.ahp;
        },
        set: function (a) {
            var b = this.ahs;
            if (a != b) {
                this.ahp = a;
                this.wd("ValueAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahs));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ago", {
        get: function () {
            return this.agl;
        },
        set: function (a) {
            var b = this.ago;
            if (a != b) {
                this.agl = a;
                this.wd("AngleAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ago));
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.get_agq = function () {
        return this.agn;
    };
    RadialBaseChart.prototype.set_agq = function (a) {
        var b = this.agq;
        if (a != b) {
            this.agn = a;
            this.wd("ValueAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agq));
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "agq", {
        get: function () {
            return this.get_agq();
        },
        set: function (a) {
            this.set_agq(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahq", {
        get: function () {
            return this.ahn;
        },
        set: function (a) {
            var b = this.ahq;
            if (a != b) {
                this.ahn = a;
                this.wd("AngleAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahq));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahr", {
        get: function () {
            return this.aho;
        },
        set: function (a) {
            var b = this.ahr;
            if (a != b) {
                this.aho = a;
                this.wd("ValueAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahr));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahv", {
        get: function () {
            return this.aht;
        },
        set: function (a) {
            var b = this.ahv;
            if (a != b) {
                this.aht = a;
                this.wd("AngleAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ahv));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahw", {
        get: function () {
            return this.ahu;
        },
        set: function (a) {
            var b = this.ahw;
            if (a != b) {
                this.ahu = a;
                this.wd("ValueAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ahw));
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.get_aaz = function () {
        return this.aay;
    };
    RadialBaseChart.prototype.set_aaz = function (a) {
        var b = this.aaz;
        if (a != b) {
            this.aay = a;
            this.wd("ValueAxisLabelLocation", enumGetBox(ValueAxisLabelLocation_$type, b), enumGetBox(ValueAxisLabelLocation_$type, this.aaz));
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "aaz", {
        get: function () {
            return this.get_aaz();
        },
        set: function (a) {
            this.set_aaz(a);
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.get_aap = function () {
        return this.aao;
    };
    RadialBaseChart.prototype.set_aap = function (a) {
        var b = this.aap;
        if (a != b) {
            this.aao = a;
            this.wd("AngleAxisLabelLocation", enumGetBox(AngleAxisLabelLocation_$type, b), enumGetBox(AngleAxisLabelLocation_$type, this.aap));
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "aap", {
        get: function () {
            return this.get_aap();
        },
        set: function (a) {
            this.set_aap(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "adv", {
        get: function () {
            return this.adg;
        },
        set: function (a) {
            var b = this.adg;
            if (a != b) {
                this.adg = a;
                this.wd("AngleAxisLabelFormat", b, this.adg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aam", {
        get: function () {
            return this.aak;
        },
        set: function (a) {
            var b = this.aak;
            if (a != b) {
                this.aak = a;
                this.wd("AngleAxisLabelFormatSpecifiers", b, this.aak);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ae3", {
        get: function () {
            return this.adk;
        },
        set: function (a) {
            var b = this.adk;
            if (a != b) {
                this.adk = a;
                this.wd("ValueAxisLabelFormat", b, this.adk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aan", {
        get: function () {
            return this.aal;
        },
        set: function (a) {
            var b = this.aal;
            if (a != b) {
                this.aal = a;
                this.wd("ValueAxisLabelFormatSpecifiers", b, this.aal);
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.$t = markType(RadialBaseChart, 'RadialBaseChart', DomainChart.$);
    return RadialBaseChart;
}(DomainChart));
export { RadialBaseChart };
