import { __extends } from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxDataAnnotationPointLayerComponent } from "./igx-data-annotation-point-layer-component";
import { IgxDataAnnotationRangeLayerComponent } from "./igx-data-annotation-range-layer-component";
import { IgxDataAnnotationShapeLayerComponent } from "./igx-data-annotation-shape-layer-component";
import { IgxDataAnnotationAxisLayerComponent } from "./igx-data-annotation-axis-layer-component";
import { IgxAnnotationLayerComponent } from "./igx-annotation-layer-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { DataAnnotationBandLayer } from "./DataAnnotationBandLayer";
import * as i0 from "@angular/core";
/**
 * Represents an annotation layer that renders bands (line with breadth) at locations of x/y values mapped to these properties:
 * StartValueXMemberPath
 * StartValueYMemberPath
 * EndValueXMemberPath
 * EndValueYMemberPath
 * AnnotationBreadthMemberPath
*/
var IgxDataAnnotationBandLayerComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxDataAnnotationBandLayerComponent, _super);
    function IgxDataAnnotationBandLayerComponent() {
        return _super.call(this) || this;
    }
    IgxDataAnnotationBandLayerComponent.prototype.createImplementation = function () {
        return new DataAnnotationBandLayer();
    };
    Object.defineProperty(IgxDataAnnotationBandLayerComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationBandLayerComponent.prototype, "annotationBreadthMemberPath", {
        /**
         * Gets or sets name of data column with breath/size of shape annotations.
        */
        get: function () {
            return this.i.aii;
        },
        set: function (v) {
            this.i.aii = v;
        },
        enumerable: false,
        configurable: true
    });
    IgxDataAnnotationBandLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDataAnnotationBandLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    IgxDataAnnotationBandLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: IgxDataAnnotationBandLayerComponent, selector: "igx-data-annotation-band-layer", inputs: { annotationBreadthMemberPath: "annotationBreadthMemberPath" }, providers: [{ provide: IgxDataAnnotationPointLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationBandLayerComponent; }) }, { provide: IgxDataAnnotationRangeLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationBandLayerComponent; }) }, { provide: IgxDataAnnotationShapeLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationBandLayerComponent; }) }, { provide: IgxDataAnnotationAxisLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationBandLayerComponent; }) }, { provide: IgxAnnotationLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationBandLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxDataAnnotationBandLayerComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
    return IgxDataAnnotationBandLayerComponent;
}(IgxDataAnnotationPointLayerComponent));
export { IgxDataAnnotationBandLayerComponent };
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDataAnnotationBandLayerComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'igx-data-annotation-band-layer',
                    template: "",
                    providers: [{ provide: IgxDataAnnotationPointLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationBandLayerComponent; }) }, { provide: IgxDataAnnotationRangeLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationBandLayerComponent; }) }, { provide: IgxDataAnnotationShapeLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationBandLayerComponent; }) }, { provide: IgxDataAnnotationAxisLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationBandLayerComponent; }) }, { provide: IgxAnnotationLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationBandLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxDataAnnotationBandLayerComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { annotationBreadthMemberPath: [{
                type: Input
            }] } });
