import { __extends } from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxDataAnnotationPointLayerComponent } from "./igx-data-annotation-point-layer-component";
import { IgxDataAnnotationRangeLayerComponent } from "./igx-data-annotation-range-layer-component";
import { IgxDataAnnotationShapeLayerComponent } from "./igx-data-annotation-shape-layer-component";
import { IgxDataAnnotationAxisLayerComponent } from "./igx-data-annotation-axis-layer-component";
import { IgxAnnotationLayerComponent } from "./igx-annotation-layer-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { DataAnnotationLineLayer } from "./DataAnnotationLineLayer";
import * as i0 from "@angular/core";
/**
 * Represents an annotation layer that renders lines at locations of x/y values mapped to these properties:
 * StartValueXMemberPath
 * StartValueYMemberPath
 * EndValueXMemberPath
 * EndValueYMemberPath
*/
var IgxDataAnnotationLineLayerComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxDataAnnotationLineLayerComponent, _super);
    function IgxDataAnnotationLineLayerComponent() {
        return _super.call(this) || this;
    }
    IgxDataAnnotationLineLayerComponent.prototype.createImplementation = function () {
        return new DataAnnotationLineLayer();
    };
    Object.defineProperty(IgxDataAnnotationLineLayerComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgxDataAnnotationLineLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDataAnnotationLineLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    IgxDataAnnotationLineLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: IgxDataAnnotationLineLayerComponent, selector: "igx-data-annotation-line-layer", providers: [{ provide: IgxDataAnnotationPointLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationLineLayerComponent; }) }, { provide: IgxDataAnnotationRangeLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationLineLayerComponent; }) }, { provide: IgxDataAnnotationShapeLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationLineLayerComponent; }) }, { provide: IgxDataAnnotationAxisLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationLineLayerComponent; }) }, { provide: IgxAnnotationLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationLineLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxDataAnnotationLineLayerComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
    return IgxDataAnnotationLineLayerComponent;
}(IgxDataAnnotationPointLayerComponent));
export { IgxDataAnnotationLineLayerComponent };
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDataAnnotationLineLayerComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'igx-data-annotation-line-layer',
                    template: "",
                    providers: [{ provide: IgxDataAnnotationPointLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationLineLayerComponent; }) }, { provide: IgxDataAnnotationRangeLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationLineLayerComponent; }) }, { provide: IgxDataAnnotationShapeLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationLineLayerComponent; }) }, { provide: IgxDataAnnotationAxisLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationLineLayerComponent; }) }, { provide: IgxAnnotationLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationLineLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxDataAnnotationLineLayerComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }], ctorParameters: function () { return []; } });
