import { __extends } from "tslib";
import { Component, Input } from '@angular/core';
import { DataAnnotationDisplayMode_$type } from "./DataAnnotationDisplayMode";
import { IgxDataAnnotationRangeLayerComponent } from "./igx-data-annotation-range-layer-component";
import { ensureEnum } from "igniteui-angular-core";
import * as i0 from "@angular/core";
/**
 * Represents a base of annotation layers that render shapes at locations of x/y values mapped to these properties:
 * StartValueXMemberPath
 * StartValueYMemberPath
 * EndValueXMemberPath
 * EndValueYMemberPath
*/
var IgxDataAnnotationPointLayerComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxDataAnnotationPointLayerComponent, _super);
    function IgxDataAnnotationPointLayerComponent() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "startValueXMemberPath", {
        /**
         * Gets or sets name of data column with x-positions for the start of annotations.
        */
        get: function () {
            return this.i.ahv;
        },
        set: function (v) {
            this.i.ahv = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "startValueYMemberPath", {
        /**
         * Gets or sets name of data column with y-positions for the start of annotations.
        */
        get: function () {
            return this.i.ahy;
        },
        set: function (v) {
            this.i.ahy = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "startLabelXMemberPath", {
        /**
         * Gets or sets mapping custom label at the start of annotations on x-axis.
        */
        get: function () {
            return this.i.aho;
        },
        set: function (v) {
            this.i.aho = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "startLabelYMemberPath", {
        /**
         * Gets or sets mapping custom label at the start of annotations on y-axis.
        */
        get: function () {
            return this.i.ahs;
        },
        set: function (v) {
            this.i.ahs = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "startLabelXDisplayMode", {
        /**
         * Gets or sets display mode of label in the start annotation on x-axis.
        */
        get: function () {
            return this.i.age;
        },
        set: function (v) {
            this.i.age = ensureEnum(DataAnnotationDisplayMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "startLabelYDisplayMode", {
        /**
         * Gets or sets display mode of label in the start annotation on y-axis.
        */
        get: function () {
            return this.i.agf;
        },
        set: function (v) {
            this.i.agf = ensureEnum(DataAnnotationDisplayMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "endValueXMemberPath", {
        /**
         * Gets or sets name of data column with x-positions for end of annotation.
        */
        get: function () {
            return this.i.ahh;
        },
        set: function (v) {
            this.i.ahh = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "endValueYMemberPath", {
        /**
         * Gets or sets name of data column with y-positions for end of annotation.
        */
        get: function () {
            return this.i.ahk;
        },
        set: function (v) {
            this.i.ahk = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "endLabelXMemberPath", {
        /**
         * Gets or sets mapping custom label at the end of annotations on x-axis.
        */
        get: function () {
            return this.i.aha;
        },
        set: function (v) {
            this.i.aha = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "endLabelYMemberPath", {
        /**
         * Gets or sets mapping custom label at the end of annotations on y-axis.
        */
        get: function () {
            return this.i.ahe;
        },
        set: function (v) {
            this.i.ahe = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "endLabelXDisplayMode", {
        /**
         * Gets or sets display mode of label at the end annotation on x-axis.
        */
        get: function () {
            return this.i.agc;
        },
        set: function (v) {
            this.i.agc = ensureEnum(DataAnnotationDisplayMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "endLabelYDisplayMode", {
        /**
         * Gets or sets display mode of label at the end annotation on y-axis.
        */
        get: function () {
            return this.i.agd;
        },
        set: function (v) {
            this.i.agd = ensureEnum(DataAnnotationDisplayMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "centerLabelXMemberPath", {
        /**
         * Gets or sets mapping custom label between start and end of data annotations on x-axis.
        */
        get: function () {
            return this.i.ag2;
        },
        set: function (v) {
            this.i.ag2 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "centerLabelYMemberPath", {
        /**
         * Gets or sets mapping custom label between start and end of data annotations on y-axis.
        */
        get: function () {
            return this.i.ag6;
        },
        set: function (v) {
            this.i.ag6 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "centerLabelXDisplayMode", {
        /**
         * Gets or sets display mode of label in the center annotation on x-axis.
        */
        get: function () {
            return this.i.aga;
        },
        set: function (v) {
            this.i.aga = ensureEnum(DataAnnotationDisplayMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationPointLayerComponent.prototype, "centerLabelYDisplayMode", {
        /**
         * Gets or sets display mode of content in the center annotation on y-axis.
        */
        get: function () {
            return this.i.agb;
        },
        set: function (v) {
            this.i.agb = ensureEnum(DataAnnotationDisplayMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    IgxDataAnnotationPointLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDataAnnotationPointLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    IgxDataAnnotationPointLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: IgxDataAnnotationPointLayerComponent, selector: "ng-component", inputs: { startValueXMemberPath: "startValueXMemberPath", startValueYMemberPath: "startValueYMemberPath", startLabelXMemberPath: "startLabelXMemberPath", startLabelYMemberPath: "startLabelYMemberPath", startLabelXDisplayMode: "startLabelXDisplayMode", startLabelYDisplayMode: "startLabelYDisplayMode", endValueXMemberPath: "endValueXMemberPath", endValueYMemberPath: "endValueYMemberPath", endLabelXMemberPath: "endLabelXMemberPath", endLabelYMemberPath: "endLabelYMemberPath", endLabelXDisplayMode: "endLabelXDisplayMode", endLabelYDisplayMode: "endLabelYDisplayMode", centerLabelXMemberPath: "centerLabelXMemberPath", centerLabelYMemberPath: "centerLabelYMemberPath", centerLabelXDisplayMode: "centerLabelXDisplayMode", centerLabelYDisplayMode: "centerLabelYDisplayMode" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
    return IgxDataAnnotationPointLayerComponent;
}(IgxDataAnnotationRangeLayerComponent));
export { IgxDataAnnotationPointLayerComponent };
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDataAnnotationPointLayerComponent, decorators: [{
            type: Component,
            args: [{
                    template: "",
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { startValueXMemberPath: [{
                type: Input
            }], startValueYMemberPath: [{
                type: Input
            }], startLabelXMemberPath: [{
                type: Input
            }], startLabelYMemberPath: [{
                type: Input
            }], startLabelXDisplayMode: [{
                type: Input
            }], startLabelYDisplayMode: [{
                type: Input
            }], endValueXMemberPath: [{
                type: Input
            }], endValueYMemberPath: [{
                type: Input
            }], endLabelXMemberPath: [{
                type: Input
            }], endLabelYMemberPath: [{
                type: Input
            }], endLabelXDisplayMode: [{
                type: Input
            }], endLabelYDisplayMode: [{
                type: Input
            }], centerLabelXMemberPath: [{
                type: Input
            }], centerLabelYMemberPath: [{
                type: Input
            }], centerLabelXDisplayMode: [{
                type: Input
            }], centerLabelYDisplayMode: [{
                type: Input
            }] } });
