import { __extends } from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxDataAnnotationShapeLayerComponent } from "./igx-data-annotation-shape-layer-component";
import { IgxDataAnnotationAxisLayerComponent } from "./igx-data-annotation-axis-layer-component";
import { IgxAnnotationLayerComponent } from "./igx-annotation-layer-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { DataAnnotationSliceLayer } from "./DataAnnotationSliceLayer";
import * as i0 from "@angular/core";
/**
 * Represents an annotation layer that renders vertical or horizontal slices/lines at values mapped to AnnotationValueMemberPath property
 * horizontal slices/lines when TargetAxis is set to Y-axis
 * vertical slices/lines when TargetAxis is set to X-axis
*/
var IgxDataAnnotationSliceLayerComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxDataAnnotationSliceLayerComponent, _super);
    function IgxDataAnnotationSliceLayerComponent() {
        return _super.call(this) || this;
    }
    IgxDataAnnotationSliceLayerComponent.prototype.createImplementation = function () {
        return new DataAnnotationSliceLayer();
    };
    Object.defineProperty(IgxDataAnnotationSliceLayerComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationSliceLayerComponent.prototype, "annotationValueMemberPath", {
        /**
         * Gets or sets name of data column with values used to position annotations.
        */
        get: function () {
            return this.i.afr;
        },
        set: function (v) {
            this.i.afr = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDataAnnotationSliceLayerComponent.prototype, "annotationLabelMemberPath", {
        /**
         * Gets or sets mapping custom label on axis annotations.
        */
        get: function () {
            return this.i.afo;
        },
        set: function (v) {
            this.i.afo = v;
        },
        enumerable: false,
        configurable: true
    });
    IgxDataAnnotationSliceLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDataAnnotationSliceLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    IgxDataAnnotationSliceLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: IgxDataAnnotationSliceLayerComponent, selector: "igx-data-annotation-slice-layer", inputs: { annotationValueMemberPath: "annotationValueMemberPath", annotationLabelMemberPath: "annotationLabelMemberPath" }, providers: [{ provide: IgxDataAnnotationShapeLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationSliceLayerComponent; }) }, { provide: IgxDataAnnotationAxisLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationSliceLayerComponent; }) }, { provide: IgxAnnotationLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationSliceLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxDataAnnotationSliceLayerComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
    return IgxDataAnnotationSliceLayerComponent;
}(IgxDataAnnotationShapeLayerComponent));
export { IgxDataAnnotationSliceLayerComponent };
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDataAnnotationSliceLayerComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'igx-data-annotation-slice-layer',
                    template: "",
                    providers: [{ provide: IgxDataAnnotationShapeLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationSliceLayerComponent; }) }, { provide: IgxDataAnnotationAxisLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationSliceLayerComponent; }) }, { provide: IgxAnnotationLayerComponent, useExisting: forwardRef(function () { return IgxDataAnnotationSliceLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxDataAnnotationSliceLayerComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { annotationValueMemberPath: [{
                type: Input
            }], annotationLabelMemberPath: [{
                type: Input
            }] } });
