import { RadialBaseChart } from "./RadialBaseChart";
import { ProportionalCategoryAngleAxis } from "./ProportionalCategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { PropertyChangedEventArgs, Type } from "igniteui-angular-core";
import { PieChartSweepDirection } from "./PieChartSweepDirection";
import { CalloutCollisionMode } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { LegendEmptyValuesMode } from "igniteui-angular-core";
import { OthersCategoryType } from "igniteui-angular-core";
import { AxisRangeBufferMode } from "./AxisRangeBufferMode";
import { RadialLabelMode } from "igniteui-angular-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { RadialBase } from "./RadialBase";
import { Series } from "./Series";
import { RadialPieSeries } from "./RadialPieSeries";
import { DataSeries } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { MarkerType } from "./MarkerType";
import { DataSeriesType } from "igniteui-angular-core";
import { XamDataChart } from "./XamDataChart";
import { OthersCategoryContext } from "./OthersCategoryContext";
/**
 * @hidden
 */
export declare abstract class DataPieBaseChart extends RadialBaseChart {
    static $t: Type;
    constructor();
    protected hg(): boolean;
    protected alf(a: (arg1: RadialBase) => void): void;
    protected alg(a: (arg1: RadialBase, arg2: number) => void): void;
    protected ald(a: (arg1: RadialPieSeries) => void): void;
    protected ale(a: (arg1: RadialPieSeries, arg2: number) => void): void;
    protected xa(): void;
    protected c2(a: Series, b: number): MarkerType;
    protected w8(a: DataSeries): void;
    protected hc(a: DataSeries): boolean;
    protected xb(): void;
    private aik;
    get angleAxis(): ProportionalCategoryAngleAxis;
    set angleAxis(a: ProportionalCategoryAngleAxis);
    private aid;
    get valueAxis(): NumericRadiusAxis;
    set valueAxis(a: NumericRadiusAxis);
    protected get_aiy(): boolean;
    protected get aiy(): boolean;
    protected dc(a: DataSeries, b: DataSeriesType): Series;
    protected vn(a: Series, b: number): void;
    private aiq;
    protected aaq(): Axis;
    protected aar(): Axis;
    protected ux(): void;
    protected alh(a: any, b: PropertyChangedEventArgs): void;
    protected ali(a: any, b: PropertyChangedEventArgs): void;
    protected ur(a: Series, b: number): void;
    protected af9(a: Axis): void;
    protected af7(a: Axis): void;
    protected vi(a: XamDataChart): void;
    protected wd(a: string, b: any, c: any): void;
    private ajx;
    get aku(): string;
    set aku(a: string);
    private ah0;
    get ah4(): any[];
    set ah4(a: any[]);
    private ajt;
    get ake(): string;
    set ake(a: string);
    private ahy;
    get ah2(): any[];
    set ah2(a: any[]);
    private ajv;
    get akn(): string;
    set akn(a: string);
    private ahz;
    get ah3(): any[];
    set ah3(a: any[]);
    private ajs;
    get aka(): string;
    set aka(a: string);
    private ahx;
    get ah1(): any[];
    set ah1(a: any[]);
    private ai4;
    get aje(): number;
    set aje(a: number);
    private aii;
    get aij(): PieChartSweepDirection;
    set aij(a: PieChartSweepDirection);
    private ah7;
    get ah8(): CalloutCollisionMode;
    set ah8(a: CalloutCollisionMode);
    private alk;
    get alm(): Brush;
    set alm(a: Brush);
    private alj;
    get all(): Brush;
    set all(a: Brush);
    private ajy;
    get ala(): string;
    set ala(a: string);
    private ajr;
    get aj8(): string;
    set aj8(a: string);
    private aib;
    get aic(): LegendEmptyValuesMode;
    set aic(a: LegendEmptyValuesMode);
    private aig;
    get aih(): OthersCategoryType;
    set aih(a: OthersCategoryType);
    private ai5;
    get ajf(): number;
    set ajf(a: number);
    private aju;
    get akj(): string;
    set akj(a: string);
    aif(): OthersCategoryContext;
    private ajq;
    get aj5(): string;
    set aj5(a: string);
    private aiu;
    get ai0(): boolean;
    set ai0(a: boolean);
    private ah5;
    get ah6(): AxisRangeBufferMode;
    set ah6(a: AxisRangeBufferMode);
    private ai2;
    get ajc(): number;
    set ajc(a: number);
    private ai3;
    get ajd(): number;
    set ajd(a: number);
    private ai8;
    get ajk(): number;
    set ajk(a: number);
    private aiv;
    get ai1(): boolean;
    set ai1(a: boolean);
    private ajo;
    get ajp(): number;
    set ajp(a: number);
    private aja;
    get ajm(): number;
    set ajm(a: number);
    private ai9;
    get ajl(): number;
    set ajl(a: number);
    private ajb;
    get ajn(): number;
    set ajn(a: number);
    get ajj(): number;
    get aji(): number;
    private ai6;
    get ajg(): number;
    set ajg(a: number);
    private ai7;
    get ajh(): number;
    set ajh(a: number);
    private ajw;
    get aks(): string;
    set aks(a: string);
    private ain;
    get aip(): RadialLabelMode;
    set aip(a: RadialLabelMode);
    private aim;
    get aio(): RadialLabelMode;
    set aio(a: RadialLabelMode);
    private air;
    get aiw(): boolean;
    set aiw(a: boolean);
    private ait;
    get aiz(): boolean;
    set aiz(a: boolean);
    private ah9;
    get aia(): CollisionAvoidanceType;
    set aia(a: CollisionAvoidanceType);
    private ais;
    get aix(): boolean;
    set aix(a: boolean);
}
