import { Brush } from "igniteui-angular-core";
import { XYChart } from "./XYChart";
import { DomWrapper } from "igniteui-angular-core";
import { EventArgs, IList, Type } from "igniteui-angular-core";
import { IZoomSlider } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { DataSeriesType } from "igniteui-angular-core";
import { IDataSeriesAdapterRule } from "igniteui-angular-core";
import { XamDataChart } from "./XamDataChart";
import { DomainType } from "./DomainType";
import { FinancialChartVolumeType } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode } from "./FinancialChartYAxisMode";
import { FinancialChartType } from "./FinancialChartType";
import { HorizontalAlignment } from "igniteui-angular-core";
import { FinancialIndicatorTypeCollection } from "./FinancialIndicatorTypeCollection";
import { FinancialOverlayTypeCollection } from "./FinancialOverlayTypeCollection";
import { FinancialChartZoomSliderType } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-angular-core";
import { IndicatorDisplayTypeCollection } from "./IndicatorDisplayTypeCollection";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { CustomIndicatorNameCollection } from "./CustomIndicatorNameCollection";
import { IChartLegend } from "igniteui-angular-core";
import { ObservableCollection$1 } from "igniteui-angular-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Series } from "./Series";
import { Axis } from "./Axis";
import { DataSeries } from "igniteui-angular-core";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerType } from "./MarkerType";
import { IZoomableCategoryAxis } from "./IZoomableCategoryAxis";
import { TitleSettings } from "./TitleSettings";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType } from "igniteui-angular-core";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorVisualData } from "./FinancialChartRangeSelectorVisualData";
/**
 * @hidden
 */
export declare class FinancialChart extends XYChart {
    static $t: Type;
    protected wi(a: string, b: any, c: any): void;
    private aqb;
    private aqa;
    private ap7;
    private aqk;
    private ajp;
    provideGrid(a: DomWrapper): void;
    onDocumentClick(a: Event): void;
    private amn;
    private aml;
    private ami;
    private amk;
    private amm;
    private amj;
    getContext(): FinancialChartContext;
    provideContainer(a: any): void;
    private aqv;
    private aq9;
    private apr;
    private aq7;
    setGridRows(): void;
    protected vm(): void;
    private aqr;
    private aqs;
    private aq1;
    private apq;
    private aqh;
    protected vj(a: XamDataChart): void;
    private arc;
    private arf;
    private ard;
    private are;
    alz(): number;
    vv(source_: any, a: number, b: any): void;
    vw(source_: any, a: number, b: any): void;
    vu(source_: any): void;
    vy(source_: any, a: number, b: any, c: any): void;
    protected vp(a: Series, b: number): void;
    private aiv;
    private get aiw();
    private set aiw(value);
    private am5;
    get anc(): any;
    set anc(a: any);
    private am6;
    get and(): any;
    set and(a: any);
    private am2;
    get am9(): any;
    set am9(a: any);
    private am7;
    get ane(): any;
    set ane(a: any);
    private am8;
    get anf(): any;
    set anf(a: any);
    private am3;
    get ana(): any;
    set ana(a: any);
    private am4;
    get anb(): any;
    set anb(a: any);
    private akd;
    get ake(): IZoomSlider;
    set ake(a: IZoomSlider);
    protected get_j2(): number;
    protected set_j2(a: number): void;
    protected get_g6(): boolean;
    protected set_g6(a: boolean): void;
    private aln;
    get al4(): number;
    set al4(a: number);
    constructor();
    protected aao(): Axis;
    protected aap(): Axis;
    onAttachedToUI(): void;
    onDetachedFromUI(): void;
    protected be(a: DataSeries): DataSeriesType;
    protected get_h2(): List$1<DataSeriesType>;
    protected get h2(): List$1<DataSeriesType>;
    protected get_h1(): List$1<IDataSeriesAdapterRule>;
    protected get h1(): List$1<IDataSeriesAdapterRule>;
    private aii;
    private ajw;
    private aih;
    protected ux(): void;
    protected ur(a: Series, b: number): void;
    protected c1(a: Series): MarkerType;
    protected w8(a: DataSeries): void;
    protected xb(): void;
    private ai0;
    private aiz;
    private ai9;
    private ai2;
    private ano;
    private aij;
    private ajx;
    private aj3;
    private aj4;
    private aj2;
    private aj5;
    private get akm();
    private ajj;
    private get ajk();
    private get akp();
    private ajh;
    private get aji();
    private get akn();
    private ajl;
    private get ajm();
    private get ako();
    private ajq;
    private get ajr();
    protected dc(a: DataSeries, b: DataSeriesType): Series;
    protected xa(): void;
    protected agc(a: (arg1: Axis) => void, b: string): void;
    protected agh(a: (arg1: Axis) => void, b: boolean): void;
    protected aqj(a: (arg1: IZoomableCategoryAxis) => void): void;
    protected agf(a: (arg1: TitleSettings) => void): void;
    protected agk(a: (arg1: TitleSettings) => void): void;
    protected agi(a: (arg1: AxisLabelSettings) => void): void;
    protected agd(a: (arg1: AxisLabelSettings) => void): void;
    protected vi(a: XamDataChart): void;
    private static am0;
    private ang;
    private aoj;
    private ap1;
    private apn;
    private apo;
    private apt;
    private apw;
    private apu;
    private apv;
    private apx;
    private amu;
    protected u7(a: (arg1: Series, arg2: number) => void): void;
    private aj9;
    private get volumeChart();
    private set volumeChart(value);
    private aqm;
    private akq;
    private aku;
    private akr;
    private akt;
    private aql;
    private aj6;
    private aj8;
    private aq3;
    l5(): any;
    anl(): string;
    private aj7;
    private aq2;
    private akz;
    private aq0;
    protected vf(): void;
    protected get_hd(): boolean;
    protected get ak5(): boolean;
    private aq8;
    private aqn;
    protected v3(a: (arg1: XamDataChart) => void, b: boolean, c: string): void;
    private apz;
    private aqw;
    private get ak4();
    private ap0;
    private akv;
    private aqq;
    private ap4;
    private ap9;
    private ap8;
    private ap2;
    private ap3;
    private aqd;
    private aqg;
    private aqe;
    private app;
    private aqu;
    private aq6;
    private ap5;
    private aq4;
    private aky;
    private aqc;
    private apy;
    private aqy;
    private aqx;
    private aqp;
    private ap6;
    private ak6;
    private aq5;
    private aps;
    private aqz;
    protected xf(a: Series, b: Series, c: DataSeries): void;
    private ann;
    protected af7(a: Axis): void;
    protected af9(a: Axis): void;
    private aqf;
    protected vn(a: Series, b: number): void;
    protected vo(a: Series, b: number): void;
    protected wd(a: string, b: any, c: any): void;
    protected get_cb(): DomainType;
    get cb(): DomainType;
    private akl;
    get ak3(): boolean;
    set ak3(a: boolean);
    private amt;
    get am1(): number;
    set am1(a: number);
    private alu;
    get amd(): number;
    set amd(a: number);
    private alw;
    get amf(): number;
    set amf(a: number);
    private alv;
    get ame(): number;
    set ame(a: number);
    private alx;
    get amg(): number;
    set amg(a: number);
    get amc(): number;
    get amb(): number;
    private ai1;
    get ai3(): FinancialChartVolumeType;
    set ai3(a: FinancialChartVolumeType);
    private ai4;
    get ai5(): FinancialChartXAxisMode;
    set ai5(a: FinancialChartXAxisMode);
    private alp;
    get al6(): number;
    set al6(a: number);
    private als;
    get al9(): number;
    set al9(a: number);
    private alq;
    get al7(): number;
    set al7(a: number);
    private alr;
    get al8(): number;
    set al8(a: number);
    private alt;
    get ama(): number;
    set ama(a: number);
    private ai6;
    get ai7(): FinancialChartYAxisMode;
    set ai7(a: FinancialChartYAxisMode);
    private akg;
    get akw(): boolean;
    set akw(a: boolean);
    private aix;
    get aiy(): FinancialChartType;
    set aiy(a: FinancialChartType);
    protected get_agq(): HorizontalAlignment;
    protected set_agq(a: HorizontalAlignment): void;
    private akh;
    get akx(): boolean;
    set akx(a: boolean);
    private ajb;
    get ajc(): FinancialIndicatorTypeCollection;
    set ajc(a: FinancialIndicatorTypeCollection);
    private ajd;
    get aje(): FinancialOverlayTypeCollection;
    set aje(a: FinancialOverlayTypeCollection);
    private ak8;
    private get indicatorCharts();
    private set indicatorCharts(value);
    private akj;
    get ak1(): boolean;
    set ak1(a: boolean);
    protected get_ka(): number;
    protected set_ka(a: number): void;
    private static readonly aow;
    private aki;
    get ak0(): boolean;
    set ak0(a: boolean);
    private static readonly ao7;
    private akk;
    get ak2(): boolean;
    set ak2(a: boolean);
    private aka;
    get zoomSliderChart(): XamDataChart;
    set zoomSliderChart(a: XamDataChart);
    private ajv;
    private get zoomSliderAxis();
    private set zoomSliderAxis(value);
    private aig;
    private get zoomSliderXAxis();
    private set zoomSliderXAxis(value);
    private ai8;
    get aja(): FinancialChartZoomSliderType;
    set aja(a: FinancialChartZoomSliderType);
    private ahz;
    get ah7(): BrushCollection;
    set ah7(a: BrushCollection);
    private ah0;
    get ah8(): BrushCollection;
    set ah8(a: BrushCollection);
    private ah1;
    get ah9(): BrushCollection;
    set ah9(a: BrushCollection);
    private ah2;
    get aia(): BrushCollection;
    set aia(a: BrushCollection);
    private ah4;
    get aic(): BrushCollection;
    set aic(a: BrushCollection);
    private ah3;
    get aib(): BrushCollection;
    set aib(a: BrushCollection);
    private ahy;
    get ah6(): BrushCollection;
    set ah6(a: BrushCollection);
    private ahx;
    get ah5(): BrushCollection;
    set ah5(a: BrushCollection);
    private alo;
    get al5(): number;
    set al5(a: number);
    private alm;
    get al3(): number;
    set al3(a: number);
    private all;
    get al2(): number;
    set al2(a: number);
    private alk;
    get al1(): number;
    set al1(a: number);
    private ajn;
    get ajo(): IndicatorDisplayTypeCollection;
    set ajo(a: IndicatorDisplayTypeCollection);
    private amp;
    get amw(): number;
    set amw(a: number);
    private alj;
    get al0(): number;
    set al0(a: number);
    private ams;
    get amz(): number;
    set amz(a: number);
    private amq;
    get amx(): number;
    set amx(a: number);
    private amo;
    get amv(): number;
    set amv(a: number);
    private amr;
    get amy(): number;
    set amy(a: number);
    private ais;
    get aiu(): FinancialChartRangeSelectorOptionCollection;
    set aiu(a: FinancialChartRangeSelectorOptionCollection);
    ait: FinancialChartRangeSelectorOptionCollection;
    private aio;
    get customIndicatorNames(): CustomIndicatorNameCollection;
    set customIndicatorNames(a: CustomIndicatorNameCollection);
    applyCustomIndicators: (sender: any, e: FinancialChartCustomIndicatorArgs) => void;
    protected get_he(): boolean;
    protected set_he(a: boolean): void;
    private ara;
    get arb(): Brush;
    set arb(a: Brush);
    private aly;
    get amh(): number;
    set amh(a: number);
    private akf;
    get aks(): boolean;
    set aks(a: boolean);
    private ajf;
    get ajg(): IChartLegend;
    set ajg(a: IChartLegend);
    private aif;
    private get xAxis();
    private set xAxis(value);
    private aju;
    private get yAxis();
    private set yAxis(value);
    private ajt;
    private get volumeAxis();
    private set volumeAxis(value);
    private aie;
    private get volumeXAxis();
    private set volumeXAxis(value);
    private ajs;
    private get indicatorAxis();
    private set indicatorAxis(value);
    private aid;
    private get indicatorXAxis();
    private set indicatorXAxis(value);
    private ak7;
    private get ala();
    private set ala(value);
    private ak9;
    private get alc();
    private set alc(value);
    private alg;
    get ali(): Date;
    set ali(a: Date);
    private alf;
    get alh(): Date;
    set alh(a: Date);
    private ald;
    get xAxisBreaks(): ObservableCollection$1<any>;
}
/**
 * @hidden
 */
export declare class FinancialChartToolbar extends TemplatedHtmlControl {
    static $t: Type;
    bg(a: DomWrapper): void;
    bl(a: Event): void;
    private o;
    constructor(a: FinancialChart, b: any);
    private r;
    get s(): FinancialChartRangeSelector;
    set s(a: FinancialChartRangeSelector);
    private z;
    get aa(): FinancialChartTypePicker;
    set aa(a: FinancialChartTypePicker);
    private p;
    get q(): FinancialChartIndicatorMenu;
    set q(a: FinancialChartIndicatorMenu);
    private bm;
    private bh;
    private bi;
    private bj;
    w: FinancialChartToolbarViewModel;
    v(): FinancialChartToolbarContext;
    l(a: any): void;
    private bk;
    private aq;
    get au(): Date;
    set au(a: Date);
    private ap;
    get at(): Date;
    set at(a: Date);
    private ao;
    get as(): Date;
    set as(a: Date);
    private an;
    get ar(): Date;
    set ar(a: Date);
    rangeChanged: (sender: any, e: EventArgs) => void;
    chartTypeChanged: (sender: any, e: EventArgs) => void;
    trendLineTypeChanged: (sender: any, e: EventArgs) => void;
    volumeTypeChanged: (sender: any, e: EventArgs) => void;
    indicatorTypesChanged: (sender: any, e: EventArgs) => void;
    overlayTypesChanged: (sender: any, e: EventArgs) => void;
    bn(): void;
    private x;
    get y(): FinancialChartType;
    set y(a: FinancialChartType);
    private ah;
    get ai(): TrendLineType;
    set ai(a: TrendLineType);
    private ab;
    get ac(): FinancialChartVolumeType;
    set ac(a: FinancialChartVolumeType);
    private ad;
    get ae(): FinancialIndicatorTypeCollection;
    set ae(a: FinancialIndicatorTypeCollection);
    private af;
    get ag(): FinancialOverlayTypeCollection;
    set ag(a: FinancialOverlayTypeCollection);
    static am(a: IList, b: IList): boolean;
    aj(): FinancialChartToolbarVisualData;
    private t;
    get u(): FinancialChartRangeSelectorOptionCollection;
    set u(a: FinancialChartRangeSelectorOptionCollection);
    private ak;
    get al(): boolean;
    set al(a: boolean);
}
/**
 * @hidden
 */
export declare class FinancialChartRangeSelector extends TemplatedHtmlControl {
    static $t: Type;
    private static x;
    q: FinancialChartRangeSelectorViewModel;
    get v(): Date;
    set v(a: Date);
    get u(): Date;
    set u(a: Date);
    get t(): Date;
    set t(a: Date);
    get s(): Date;
    set s(a: Date);
    ab(): void;
    constructor(a: any);
    l(a: any): void;
    private z;
    rangeChanged: (sender: any, e: EventArgs) => void;
    r(): FinancialChartRangeSelectorVisualData;
    get o(): FinancialChartRangeSelectorOptionCollection;
    set o(a: FinancialChartRangeSelectorOptionCollection);
    private aa;
    private p;
}
