import { IgxDataAnnotationPointLayerComponent } from "./igx-data-annotation-point-layer-component";
import { DataAnnotationBandLayer } from "./DataAnnotationBandLayer";
import * as i0 from "@angular/core";
/**
 * Represents an annotation layer that renders bands (line with breadth) at locations of x/y values mapped to these properties:
 * StartValueXMemberPath
 * StartValueYMemberPath
 * EndValueXMemberPath
 * EndValueYMemberPath
 * AnnotationBreadthMemberPath
*/
export declare class IgxDataAnnotationBandLayerComponent extends IgxDataAnnotationPointLayerComponent {
    protected createImplementation(): DataAnnotationBandLayer;
    /**
                                 * @hidden
                                 */
    get i(): DataAnnotationBandLayer;
    constructor();
    /**
     * Gets or sets name of data column with breath/size of shape annotations.
    */
    get annotationBreadthMemberPath(): string;
    set annotationBreadthMemberPath(v: string);
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxDataAnnotationBandLayerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxDataAnnotationBandLayerComponent, "igx-data-annotation-band-layer", never, { "annotationBreadthMemberPath": "annotationBreadthMemberPath"; }, {}, never, never>;
}
