import { DataAnnotationItem as DataAnnotationItem_internal } from "./DataAnnotationItem";
/**
 * Represents a definition of data annotation displayed by the DataAnnotationShapeLayer
*/
export declare class IgxDataAnnotationItem {
    protected createImplementation(): DataAnnotationItem_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): DataAnnotationItem_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets data index associated with the annotation
    */
    get dataIndex(): number;
    set dataIndex(v: number);
    static ngAcceptInputType_dataIndex: number | string;
    /**
     * Gets or sets a label displayed at start annotation shape on x-axis
    */
    get startLabelX(): string;
    set startLabelX(v: string);
    /**
     * Gets or sets a label displayed at start annotation shape on y-axis
    */
    get startLabelY(): string;
    set startLabelY(v: string);
    /**
     * Gets or sets a label displayed at end annotation shape on x-axis
    */
    get endLabelX(): string;
    set endLabelX(v: string);
    /**
     * Gets or sets a label displayed at end annotation shape on y-axis
    */
    get endLabelY(): string;
    set endLabelY(v: string);
    /**
     * Gets or sets a label displayed at center annotation shape on y-axis
    */
    get centerLabelY(): string;
    set centerLabelY(v: string);
    /**
     * Gets or sets a label displayed at center annotation shape on x-axis
    */
    get centerLabelX(): string;
    set centerLabelX(v: string);
    /**
     * Gets X coordinate for the start of annotation shape
    */
    get shapeStartX(): number;
    set shapeStartX(v: number);
    static ngAcceptInputType_shapeStartX: number | string;
    /**
     * Gets Y coordinate for the start of annotation shape
    */
    get shapeStartY(): number;
    set shapeStartY(v: number);
    static ngAcceptInputType_shapeStartY: number | string;
    /**
     * Gets X coordinate for the end of annotation shape
    */
    get shapeEndX(): number;
    set shapeEndX(v: number);
    static ngAcceptInputType_shapeEndX: number | string;
    /**
     * Gets Y coordinate for the end of annotation shape
    */
    get shapeEndY(): number;
    set shapeEndY(v: number);
    static ngAcceptInputType_shapeEndY: number | string;
    /**
     * Gets X coordinate for the center of annotation shape
    */
    get shapeCenterX(): number;
    set shapeCenterX(v: number);
    static ngAcceptInputType_shapeCenterX: number | string;
    /**
     * Gets Y coordinate for the center of annotation shape
    */
    get shapeCenterY(): number;
    set shapeCenterY(v: number);
    static ngAcceptInputType_shapeCenterY: number | string;
    /**
     * Gets or sets fill brush of the annotation shape
    */
    get shapeBrush(): string;
    set shapeBrush(v: string);
    /**
     * Gets or sets outline brush of the annotation shape
    */
    get shapeOutline(): string;
    set shapeOutline(v: string);
    /**
     * Gets or sets outline thickness of the annotation shape
    */
    get shapeThickness(): number;
    set shapeThickness(v: number);
    static ngAcceptInputType_shapeThickness: number | string;
    findByName(name: string): any;
}
