import { IgxDataAnnotationShapeLayerComponent } from "./igx-data-annotation-shape-layer-component";
import { DataAnnotationSliceLayer } from "./DataAnnotationSliceLayer";
import * as i0 from "@angular/core";
/**
 * Represents an annotation layer that renders vertical or horizontal slices/lines at values mapped to AnnotationValueMemberPath property
 * horizontal slices/lines when TargetAxis is set to Y-axis
 * vertical slices/lines when TargetAxis is set to X-axis
*/
export declare class IgxDataAnnotationSliceLayerComponent extends IgxDataAnnotationShapeLayerComponent {
    protected createImplementation(): DataAnnotationSliceLayer;
    /**
                                 * @hidden
                                 */
    get i(): DataAnnotationSliceLayer;
    constructor();
    /**
     * Gets or sets name of data column with values used to position annotations.
    */
    get annotationValueMemberPath(): string;
    set annotationValueMemberPath(v: string);
    /**
     * Gets or sets mapping custom label on axis annotations.
    */
    get annotationLabelMemberPath(): string;
    set annotationLabelMemberPath(v: string);
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxDataAnnotationSliceLayerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxDataAnnotationSliceLayerComponent, "igx-data-annotation-slice-layer", never, { "annotationValueMemberPath": "annotationValueMemberPath"; "annotationLabelMemberPath": "annotationLabelMemberPath"; }, {}, never, never>;
}
