import { AnnotationAppearanceMode } from "./AnnotationAppearanceMode";
import { OverlayTextLocation } from "./OverlayTextLocation";
import { OverlayTextInfo as OverlayTextInfo_internal } from "./OverlayTextInfo";
/**
 * Represents data annotation
*/
export declare class IgxOverlayTextInfo {
    protected createImplementation(): OverlayTextInfo_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): OverlayTextInfo_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets Horizontal Margin for the overlay text
    */
    get horizontalMargin(): number;
    set horizontalMargin(v: number);
    static ngAcceptInputType_horizontalMargin: number | string;
    /**
     * Gets or sets Horizontal Padding for the overlay text
    */
    get horizontalPadding(): number;
    set horizontalPadding(v: number);
    static ngAcceptInputType_horizontalPadding: number | string;
    /**
     * Gets or sets Vertical Padding for the overlay text
    */
    get verticalPadding(): number;
    set verticalPadding(v: number);
    static ngAcceptInputType_verticalPadding: number | string;
    /**
     * Gets or sets Vertical Margin for the overlay text
    */
    get verticalMargin(): number;
    set verticalMargin(v: number);
    static ngAcceptInputType_verticalMargin: number | string;
    /**
     * Gets or sets boarder border radius of the overlay text
    */
    get borderRadius(): number;
    set borderRadius(v: number);
    static ngAcceptInputType_borderRadius: number | string;
    /**
     * Gets or sets boarder thickness of the overlay text
    */
    get borderThickness(): number;
    set borderThickness(v: number);
    static ngAcceptInputType_borderThickness: number | string;
    /**
     * Gets or sets appearance shift of the overlay text border
    */
    get borderShift(): number;
    set borderShift(v: number);
    static ngAcceptInputType_borderShift: number | string;
    /**
     * Gets or sets appearance shift of the overlay text background
    */
    get backgroundShift(): number;
    set backgroundShift(v: number);
    static ngAcceptInputType_backgroundShift: number | string;
    /**
     * Gets or sets appearance shift of the overlay text color
    */
    get textColorShift(): number;
    set textColorShift(v: number);
    static ngAcceptInputType_textColorShift: number | string;
    /**
     * Gets or sets appearance mode of the overlay text border
    */
    get borderMode(): AnnotationAppearanceMode;
    set borderMode(v: AnnotationAppearanceMode);
    static ngAcceptInputType_borderMode: AnnotationAppearanceMode | string;
    /**
     * Gets or sets appearance mode of the overlay text background
    */
    get backgroundMode(): AnnotationAppearanceMode;
    set backgroundMode(v: AnnotationAppearanceMode);
    static ngAcceptInputType_backgroundMode: AnnotationAppearanceMode | string;
    /**
     * Gets or sets appearance mode of the overlay text color
    */
    get textColorMode(): AnnotationAppearanceMode;
    set textColorMode(v: AnnotationAppearanceMode);
    static ngAcceptInputType_textColorMode: AnnotationAppearanceMode | string;
    /**
     * Gets or sets content of the overlay text
    */
    get textContent(): string;
    set textContent(v: string);
    /**
     * Gets or sets rotation angle of the overlay text
    */
    get textAngle(): number;
    set textAngle(v: number);
    static ngAcceptInputType_textAngle: number | string;
    /**
     * Gets or sets visibility of the overlay text
    */
    get textVisible(): boolean;
    set textVisible(v: boolean);
    static ngAcceptInputType_textVisible: boolean | string;
    /**
     * Gets or sets location of the overlay text in relation to shape annotation
    */
    get textLocation(): OverlayTextLocation;
    set textLocation(v: OverlayTextLocation);
    static ngAcceptInputType_textLocation: OverlayTextLocation | string;
    /**
     * Gets or sets color of the overlay text
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or sets background of the overlay text
    */
    get background(): string;
    set background(v: string);
    /**
     * Gets or sets border stroke of the overlay text
    */
    get borderStroke(): string;
    set borderStroke(v: string);
    /**
     * Gets or sets shape brush associated with the overlay text
    */
    get shapeBrush(): string;
    set shapeBrush(v: string);
    /**
     * Gets or sets shape outline associated with the overlay text
    */
    get shapeOutline(): string;
    set shapeOutline(v: string);
    findByName(name: string): any;
}
