import { IgxSeriesComponent } from "./igx-series-component";
import { TrendLineType } from "igniteui-angular-core";
import { IgxAnnotationLayerComponent } from "./igx-annotation-layer-component";
import { TrendLineLayer } from "./TrendLineLayer";
import * as i0 from "@angular/core";
/**
 * Represents the class of the value overlay. The value overlay is a line or circle representing a value on an axis.
*/
export declare class IgxTrendLineLayerComponent extends IgxAnnotationLayerComponent {
    protected createImplementation(): TrendLineLayer;
    /**
                                 * @hidden
                                 */
    get i(): TrendLineLayer;
    constructor();
    get isAnnotationLayer(): boolean;
    static ngAcceptInputType_isAnnotationLayer: boolean | string;
    get isLineOnly(): boolean;
    static ngAcceptInputType_isLineOnly: boolean | string;
    /**
     * Gets or sets the name of the series to target this annotation to.
    */
    get targetSeriesName(): string;
    set targetSeriesName(v: string);
    /**
     * Gets or sets the series to target this annotation to.
    */
    get targetSeries(): IgxSeriesComponent;
    set targetSeries(v: IgxSeriesComponent);
    /**
     * Gets the actual series being targeted by this annotation.
    */
    get actualTargetSeries(): IgxSeriesComponent;
    set actualTargetSeries(v: IgxSeriesComponent);
    /**
     * Gets or sets the trend type for the current series object.
    */
    get trendLineType(): TrendLineType;
    set trendLineType(v: TrendLineType);
    static ngAcceptInputType_trendLineType: TrendLineType | string;
    /**
     * Gets or sets the trend line period for the target series.
     * The typical, and initial, value for trend line period is 7.
    */
    get trendLinePeriod(): number;
    set trendLinePeriod(v: number);
    static ngAcceptInputType_trendLinePeriod: number | string;
    get isUsableInLegend(): boolean;
    static ngAcceptInputType_isUsableInLegend: boolean | string;
    findByName(name: string): any;
    protected _styling(container: any, component: any, parent?: any): void;
    onApplyTemplate(): void;
    getManagerIdentifier(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxTrendLineLayerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxTrendLineLayerComponent, "igx-trend-line-layer", never, { "targetSeriesName": "targetSeriesName"; "targetSeries": "targetSeries"; "actualTargetSeries": "actualTargetSeries"; "trendLineType": "trendLineType"; "trendLinePeriod": "trendLinePeriod"; }, {}, never, never>;
}
